Package: warp
Title: Group Dates
Version: 0.2.3
Authors@R: c(
    person("Davis", "Vaughan", , "davis@posit.co", role = c("aut", "cre")),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49"))
  )
Description: Tooling to group dates by a variety of periods including:
    yearly, monthly, by second, by week of the month, and more.  The
    groups are defined in such a way that they also represent the distance
    between dates in terms of the period. This extracts valuable
    information that can be used in further calculations that rely on a
    specific temporal spacing between observations.
License: MIT + file LICENSE
URL: https://github.com/DavisVaughan/warp,
        https://davisvaughan.github.io/warp/
BugReports: https://github.com/DavisVaughan/warp/issues
Depends: R (>= 4.0.0)
Suggests: covr, knitr, rmarkdown, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/build/compilation-database: true
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Config/usethis/last-upkeep: 2025-11-13
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-01-13 02:10:17 UTC; davis
Author: Davis Vaughan [aut, cre],
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>)
Maintainer: Davis Vaughan <davis@posit.co>
Repository: CRAN
Date/Publication: 2026-01-13 06:10:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-26 09:34:19 UTC; unix
Archs: warp.so.dSYM

Package: warp
Title: Group Dates
Version: 0.2.3
Authors@R: c(
    person("Davis", "Vaughan", , "davis@posit.co", role = c("aut", "cre")),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49"))
  )
Description: Tooling to group dates by a variety of periods including:
    yearly, monthly, by second, by week of the month, and more.  The
    groups are defined in such a way that they also represent the distance
    between dates in terms of the period. This extracts valuable
    information that can be used in further calculations that rely on a
    specific temporal spacing between observations.
License: MIT + file LICENSE
URL: https://github.com/DavisVaughan/warp,
        https://davisvaughan.github.io/warp/
BugReports: https://github.com/DavisVaughan/warp/issues
Depends: R (>= 4.0.0)
Suggests: covr, knitr, rmarkdown, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/build/compilation-database: true
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Config/usethis/last-upkeep: 2025-11-13
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-01-13 02:10:17 UTC; davis
Author: Davis Vaughan [aut, cre],
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>)
Maintainer: Davis Vaughan <davis@posit.co>
Repository: CRAN
Date/Publication: 2026-01-13 06:10:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 15:57:59 UTC; unix
Archs: warp.so.dSYM

# WARP: Wrapper around Replicated Processes
<p align="center">
  <img style="width:300px" src="https://i.imgur.com/0oS4Jih.png" />
</p>

WARP is a light-weight manager for background processes.

Functionality
* Easily spawn any process as a managed subprocess
* Automatic recover from failed process
* Runs completely async
* Cleanly exits in a safe order (subprocess, WARP manager, then main process)

### Overview
So you need to run a subprocess in the background of your Python application. How do you do it?
* If you simply start the process in an async way, how can you ensure that the process can is restarted if it exits?
* If you start the process in a synchronous way, how do you ensure that the rest of your program continues to execute?
* If you use `supervisord`, how do you ensure that all your users have `supervisord` installed ahead of time?
* If you use `celery` or some kind of heavy weight solution, you now need standalone infra and need to manage a lot of complexity

WARP makes it very simple to manage a background process in a self-healing way. The subprocess runs in a background
thread that continually monitors the health of the subprocess. WARP is also able to intelligently support interrupt
signals.

### Installation

`pip install warp`

### Usage

Import WARP
```python
from warp import Warp
```

Create a WARP object
```python
wp = Warp(command="dummy_server.py")
```

Start the WARP process

```python
wp.start()
```

The process will automatically be killed (cleanly) when the main process exits

Alternatively you may also forcefully stop this background process

```python
wp.stop()
```

### Testing

Run the following command from the repo root
```bash
pytest
```

### Python Compatibility

WARP only supports the following Python versions
* 3.7
* 3.8
* 3.9

### Contributing

WARP is a community project. Feel free to submit a PR and/or an issue if you are looking for more functionality or found a bug!

<!-- README.md is generated from README.Rmd. Please edit that file -->

# warp

<!-- badges: start -->

[![R-CMD-check](https://github.com/DavisVaughan/warp/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/DavisVaughan/warp/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/DavisVaughan/warp/graph/badge.svg)](https://app.codecov.io/gh/DavisVaughan/warp)
<!-- badges: end -->

![](https://media.giphy.com/media/jjeK2Er3E5igw/giphy.gif)

The goal of warp is to provide tooling to group dates by a variety of
periods, such as: yearly, monthly, by second, by week of the month, and
more.

``` r
library(warp)
```

## Installation

You can install the release version from CRAN with:

``` r
install.package("warp")
```

You can install the development version from
[GitHub](https://github.com/) with:

``` r
# install.packages("pak")
pak::pak("DavisVaughan/warp")
```

## Example

One of the core functions in warp is `warp_distance()`, which allows you
to provide a date time vector and compute the “distance” from an
`origin`. For example, this computes the number of months from the unix
epoch.

``` r
x <- as.Date("1970-01-01") + -2:2
x
#> [1] "1969-12-30" "1969-12-31" "1970-01-01" "1970-01-02" "1970-01-03"

warp_distance(x, period = "month")
#> [1] -1 -1  0  0  0
```

The values that `warp_distance()` returns correspond to the distance
from `x` to the `origin`, in units defined by the `period` and the width
defined by `every`. The `origin` defaults to the unix epoch of
`1970-01-01 00:00:00` in the time zone of `x`, but you can change that.
In this case the distances are saying that, for example, `"1970-01-02"`
is in the same month as the origin, and `"1969-12-31"` is 1 month group
away.

You can also compute daily distances. Rather than grouping by 1 day,
let’s lump every 2 days together, starting from the default `origin`.

``` r
# Groups 1970-01-01 and 1970-01-02 together
warp_distance(x, period = "day", every = 2)
#> [1] -1 -1  0  0  1
```

You will often want to set your own `origin` date. Let’s shift it
forward 1 to `1970-01-02`.

``` r
origin <- as.Date("1970-01-02")
origin
#> [1] "1970-01-02"

# Groups 1970-01-02 and 1970-01-03 together
warp_distance(x, period = "day", every = 2, origin = origin)
#> [1] -2 -1 -1  0  0
```

Another interesting period to group by is the `"mweek"`, i.e. the week
of the month. Notice that days 1-7 of January 1970 are grouped into the
same bucket. Also note that days 29-31 of December 1969 fell at the end
of their corresponding month. This irregular week of size 3 is treated
as the 5th week of that month, but the offset value of `-1` is still the
number of week buckets from the `origin` of `1970-01-01`.

``` r
y <- as.Date("1969-12-28") + 0:14

tibble::tibble(
  y = y,
  mweek = warp_distance(y, "mweek")
)
#> # A tibble: 15 × 2
#>    y          mweek
#>    <date>     <dbl>
#>  1 1969-12-28    -2
#>  2 1969-12-29    -1
#>  3 1969-12-30    -1
#>  4 1969-12-31    -1
#>  5 1970-01-01     0
#>  6 1970-01-02     0
#>  7 1970-01-03     0
#>  8 1970-01-04     0
#>  9 1970-01-05     0
#> 10 1970-01-06     0
#> 11 1970-01-07     0
#> 12 1970-01-08     1
#> 13 1970-01-09     1
#> 14 1970-01-10     1
#> 15 1970-01-11     1
```

## Inspiration

The algorithm for `warp_distance()` was inspired by `xts::endpoints()`.

#' Locate period boundaries for a date vector
#'
#' @description
#' `warp_boundary()` detects a change in time period along `x`, for example,
#' rolling from one month to the next. It returns the start and stop positions
#' for each contiguous period chunk in `x`.
#'
#' @details
#' The stop positions are just the [warp_change()] values, and the start
#' positions are computed from these.
#'
#' @inheritParams warp_distance
#'
#' @return
#' A two column data frame with the columns `start` and `stop`. Both are
#' double vectors representing boundaries of the date time groups.
#'
#' @export
#' @examples
#' x <- as.Date("1970-01-01") + -4:5
#' x
#'
#' # Boundaries by month
#' warp_boundary(x, "month")
#'
#' # Bound by every 5 days, relative to "1970-01-01"
#' # Creates boundaries of:
#' # [1969-12-27, 1970-01-01)
#' # [1970-01-01, 1970-01-06)
#' # [1970-01-06, 1970-01-11)
#' warp_boundary(x, "day", every = 5)
#'
#' # Bound by every 5 days, relative to the smallest value in our vector
#' origin <- min(x)
#' origin
#'
#' # Creates boundaries of:
#' # [1969-12-28, 1970-01-02)
#' # [1970-01-02, 1970-01-07)
#' warp_boundary(x, "day", every = 5, origin = origin)
warp_boundary <- function(x, period, ..., every = 1L, origin = NULL) {
  check_dots_empty("warp_boundary", ...)
  .Call(warp_warp_boundary, x, period, every, origin)
}

# withr::with_envvar()
with_envvar <- function(new, code) {
  old <- set_envvar(envs = new)
  on.exit(set_envvar(old))
  force(code)
}

set_envvar <- function(envs, action = "replace") {
  if (length(envs) == 0) {
    return()
  }
  stopifnot(is.named(envs))
  stopifnot(is.character(action), length(action) == 1)
  action <- match.arg(action, c("replace", "prefix", "suffix"))
  envs <- envs[!duplicated(names(envs), fromLast = TRUE)]
  old <- Sys.getenv(names(envs), names = TRUE, unset = NA)
  set <- !is.na(envs)
  both_set <- set & !is.na(old)
  if (any(both_set)) {
    if (action == "prefix") {
      envs[both_set] <- paste(envs[both_set], old[both_set])
    } else if (action == "suffix") {
      envs[both_set] <- paste(old[both_set], envs[both_set])
    }
  }
  if (any(set)) {
    do.call("Sys.setenv", as.list(envs[set]))
  }
  if (any(!set)) {
    Sys.unsetenv(names(envs)[!set])
  }
  invisible(old)
}

is.named <- function(x) {
  !is.null(names(x)) && all(names(x) != "")
}

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "year")

test_that("can warp_distance() by year with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "year"), 0)

  x <- as.Date("1971-01-01")
  expect_identical(warp_distance(x, "year"), 1)
})

test_that("can warp_distance() by year with 'negative' Dates", {
  x <- as.Date("1969-01-01")
  expect_identical(warp_distance(x, "year"), -1)
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "year", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "year", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "year", origin = origin))
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "year"), 0)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, class = "Date")
  expect_identical(warp_distance(x, "year"), NA_real_)

  x <- structure(NA_integer_, class = "Date")
  expect_identical(warp_distance(x, "year"), NA_real_)
})

test_that("can handle `every` with default origin", {
  x <- as.Date(c(
    "1967-01-01",
    "1968-01-01",
    "1969-01-01",
    "1970-01-01",
    "1971-01-01",
    "1972-01-01",
    "1973-01-01"
  ))

  expect_equal(
    warp_distance(x, period = "year", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin", {
  x <- as.Date(c(
    "1967-01-01",
    "1968-01-01",
    "1969-01-01",
    "1970-01-01",
    "1971-01-01",
    "1972-01-01",
    "1973-01-01"
  ))

  origin <- as.Date("1971-01-01")

  expect_equal(
    warp_distance(x, period = "year", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("fractional Date pieces are ignored", {
  # "1969-12-31 23:59:52 UTC"
  # .POSIXct(-0.0001 * 86400, "UTC")
  y <- structure(-0.0001, class = "Date")

  # But we really treat this as `new_date(0)`
  expect_equal(warp_distance(y, period = "year"), 0)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_equal(warp_distance(x, period = "year"), numeric())
  expect_equal(warp_distance(x, period = "year", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_equal(warp_distance(x, period = "year"), numeric())
  expect_equal(warp_distance(x, period = "year", every = 2), numeric())
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "year")

test_that("can warp_distance() by year with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "year"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "year"), 1)
})

test_that("can warp_distance() by year with 'negative' POSIXct", {
  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "year"), -1)

  x <- as.POSIXct("1969-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "year"), -1)

  x <- as.POSIXct("1968-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "year"), -2)
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "year"), NA)

  expect_identical(warp_distance(x, "year"), 1)
  expect_identical(warp_distance(x, "year", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "year", origin = origin1), NA)

  expect_identical(warp_distance(x, "year", origin = origin1), 0)
  expect_identical(warp_distance(x, "year", origin = origin2), -1)
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "year", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "year", origin = origin))
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "year", origin = origin)
    })
    expect_identical(out, 0)
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "year"), -1)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "year"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "year"), NA_real_)
})

test_that("can handle `every` with default origin", {
  x <- as.POSIXct(
    c(
      "1967-01-01",
      "1968-01-01",
      "1969-01-01",
      "1970-01-01",
      "1971-01-01",
      "1972-01-01",
      "1973-01-01"
    ),
    tz = "UTC"
  )

  expect_equal(
    warp_distance(x, period = "year", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin", {
  x <- as.POSIXct(
    c(
      "1967-01-01",
      "1968-01-01",
      "1969-01-01",
      "1970-01-01",
      "1971-01-01",
      "1972-01-01",
      "1973-01-01"
    ),
    tz = "UTC"
  )

  origin <- as.Date("1971-01-01")

  expect_equal(
    warp_distance(x, period = "year", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin and altered timezone", {
  x <- as.POSIXct(
    c(
      "1967-01-01",
      "1968-01-01",
      "1969-01-01",
      "1970-01-01",
      "1971-01-01",
      "1972-01-01",
      "1973-01-01"
    ),
    tz = "America/New_York"
  )

  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_equal(
    warp_distance(x, period = "year", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "year", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "year"),
    warp_distance(y, period = "year")
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "year")

test_that("can warp_distance() by year with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "year"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "year"), 1)
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "quarter")

# This uses `period = "month"` with `every = every * 3`, so just do a basic test

test_that("can warp_distance() by quarter with Date", {
  x <- as.Date(c("1970-01-01", "1970-03-31", "1970-04-01"))

  expect_identical(warp_distance(x, "quarter"), c(0, 0, 1))
})

test_that("can adjust the origin at the month level", {
  origin <- as.Date("1970-02-01")
  x <- as.Date(c("1970-01-01", "1970-04-30", "1970-05-01"))

  expect_identical(warp_distance(x, "quarter", origin = origin), c(-1, 0, 1))
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "quarter")

test_that("can warp_distance() by quarter with POSIXct", {
  x <- as.POSIXct(
    c("1970-01-01 00:00:00", "1970-03-31 23:59:59", "1970-04-01 00:00:00"),
    "UTC"
  )

  expect_identical(warp_distance(x, "quarter"), c(0, 0, 1))
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "month")

test_that("can warp_distance() by month with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "month"), 0)

  x <- as.Date("1970-02-01")
  expect_identical(warp_distance(x, "month"), 1)

  x <- as.Date("1971-02-01")
  expect_identical(warp_distance(x, "month"), 13)
})

test_that("can warp_distance() by month with 'negative' Dates", {
  x <- as.Date("1969-12-31")
  expect_identical(warp_distance(x, "month"), -1)

  x <- as.Date("1968-11-30")
  expect_identical(warp_distance(x, "month"), -14)
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "month", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "month", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "month", origin = origin))
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "month"), 0)

  x <- structure(31L, class = "Date")
  expect_identical(warp_distance(x, "month"), 1)
})

test_that("can handle `every` with default origin", {
  x <- as.Date(c(
    "1969-10-01",
    "1969-11-01",
    "1969-12-01",
    "1970-01-01",
    "1970-02-01",
    "1970-03-01",
    "1970-04-01"
  ))

  expect_equal(
    warp_distance(x, period = "month", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin", {
  x <- as.Date(c(
    "1969-10-01",
    "1969-11-01",
    "1969-12-01",
    "1970-01-01",
    "1970-02-01",
    "1970-03-01",
    "1970-04-01"
  ))

  origin <- as.Date("1970-02-01")

  expect_equal(
    warp_distance(x, period = "month", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("fractional Date pieces are ignored", {
  # "1969-12-31 23:59:52 UTC"
  # .POSIXct(-0.0001 * 86400, "UTC")
  x <- structure(-0.0001, class = "Date")

  # But we really treat this as `new_date(0)`
  expect_equal(warp_distance(x, period = "month"), 0)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_equal(warp_distance(x, period = "month"), numeric())
  expect_equal(warp_distance(x, period = "month", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_equal(warp_distance(x, period = "month"), numeric())
  expect_equal(warp_distance(x, period = "month", every = 2), numeric())
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "month")

test_that("can warp_distance() by month with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "month"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "month"), 12)
})

test_that("can warp_distance() by month with 'negative' POSIXct", {
  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "month"), -1)

  x <- as.POSIXct("1969-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "month"), -12)

  x <- as.POSIXct("1968-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "month"), -13)
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "month"), NA)

  expect_identical(warp_distance(x, "month"), 12)
  expect_identical(warp_distance(x, "month", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "month", origin = origin1), NA)

  expect_identical(warp_distance(x, "month", origin = origin1), 0)
  expect_identical(warp_distance(x, "month", origin = origin2), -12)
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "month", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "month", origin = origin))
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971-01
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "month", origin = origin)
    })
    expect_identical(out, 0)
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "month"), -1)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "month"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "month"), NA_real_)
})

test_that("can handle `every` with default origin", {
  x <- as.POSIXct(
    c(
      "1969-10-01",
      "1969-11-01",
      "1969-12-01",
      "1970-01-01",
      "1970-02-01",
      "1970-03-01",
      "1970-04-01"
    ),
    tz = "UTC"
  )

  expect_equal(
    warp_distance(x, period = "month", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin", {
  x <- as.POSIXct(
    c(
      "1969-10-01",
      "1969-11-01",
      "1969-12-01",
      "1970-01-01",
      "1970-02-01",
      "1970-03-01",
      "1970-04-01"
    ),
    tz = "UTC"
  )

  origin <- as.Date("1970-02-01")

  expect_equal(
    warp_distance(x, period = "month", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin and altered timezone", {
  x <- as.POSIXct(
    c(
      "1969-10-01",
      "1969-11-01",
      "1969-12-01",
      "1970-01-01",
      "1970-02-01",
      "1970-03-01",
      "1970-04-01"
    ),
    tz = "America/New_York"
  )

  origin <- as.POSIXct("1970-02-01", tz = "America/New_York")

  expect_equal(
    warp_distance(x, period = "month", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "month", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "month"),
    warp_distance(y, period = "month")
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "month")

test_that("can warp_distance() by month with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "month"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "month"), 12)
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "yweek")

test_that("can warp_distance() by yweek with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "yweek"), 0)

  x <- as.Date("1970-01-08")
  expect_identical(warp_distance(x, "yweek"), 1)

  x <- as.Date("1971-01-01")
  expect_identical(warp_distance(x, "yweek"), 53)
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "yweek", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "yweek", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "yweek", origin = origin))
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "yweek"), 0)

  x <- structure(31L, class = "Date")
  expect_identical(warp_distance(x, "yweek"), 4)
})

test_that("can handle `every` with default origin", {
  x <- as.Date(c(
    "1969-12-02",
    "1969-12-09",
    "1969-12-16",
    "1969-12-23",
    "1969-12-30",
    "1969-12-31",
    "1970-01-01",
    "1970-01-08",
    "1970-01-15",
    "1970-01-22"
  ))

  expect_equal(
    warp_distance(x, period = "yweek", every = 2L),
    c(-4, -3, -3, -2, -2, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 3L),
    c(-3, -2, -2, -2, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 4L),
    c(-3, -2, -2, -2, -2, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin", {
  x <- as.Date(c(
    "1969-12-02",
    "1969-12-09",
    "1969-12-16",
    "1969-12-23",
    "1969-12-30",
    "1969-12-31",
    "1970-01-01",
    "1970-01-06",
    "1970-01-07",
    "1970-01-08",
    "1970-01-15",
    "1970-01-22"
  ))

  origin <- as.Date("1970-01-08")

  expect_equal(
    warp_distance(x, period = "yweek", every = 2L, origin = origin),
    c(-4, -4, -3, -3, -2, -2, -2, -2, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 3L, origin = origin),
    c(-3, -3, -2, -2, -2, -1, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 4L, origin = origin),
    c(-3, -3, -2, -2, -2, -2, -2, -2, -1, 0, 0, 0)
  )
})

test_that("fractional Date pieces are ignored", {
  # "1969-12-31 23:59:52 UTC"
  # .POSIXct(-0.0001 * 86400, "UTC")
  x <- structure(-0.0001, class = "Date")

  # But we really treat this as `new_date(0)`
  expect_equal(warp_distance(x, period = "yweek"), 0)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_equal(warp_distance(x, period = "yweek"), numeric())
  expect_equal(warp_distance(x, period = "yweek", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_equal(warp_distance(x, period = "yweek"), numeric())
  expect_equal(warp_distance(x, period = "yweek", every = 2), numeric())
})

test_that("going backwards in time still uses groups computed from the first of the year", {
  # The 53rd yweek of 1969
  x <- as.Date("1969-12-31")
  # The 52nd yweek of 1969
  y <- as.Date("1969-12-30")
  expect_identical(warp_distance(x, "yweek"), -1)
  expect_identical(warp_distance(y, "yweek"), -2)
})

test_that("leap years in `x` affect the yweek group", {
  origin <- as.Date("1999-03-01")

  x <- as.Date(c(
    "1999-02-27",
    "1999-02-28",
    "1999-03-01",
    "1999-03-02",
    "1999-03-07",
    "1999-03-08"
  ))
  y <- as.Date(c(
    "2000-02-27",
    "2000-02-28",
    "2000-02-29",
    "2000-03-01",
    "2000-03-02",
    "2000-03-07",
    "2000-03-08"
  ))
  z <- as.Date(c(
    "2001-02-27",
    "2001-02-28",
    "2001-03-01",
    "2001-03-02",
    "2001-03-07",
    "2001-03-08"
  ))

  # 1998-03-01 -> 1999-02-21 = 51 full weeks
  # [1999-02-21, 1999-02-28) = -2
  # [1999-02-28, 1999-03-01) = -1
  # [1999-03-01, 1999-03-08) = 0
  # [1999-03-08, 1999-03-15) = 1
  expect_identical(
    warp_distance(x, period = "yweek", every = 1, origin = origin),
    c(-2, -1, 0, 0, 0, 1)
  )

  # 1999-03-01 -> 2000-02-21 = 51 full weeks
  # [2000-02-21, 2000-02-28) = 51
  # [2000-02-28, 2000-03-01) = 52
  # [2000-03-01, 2000-03-08) = 53
  # [2000-03-08, 2000-03-15) = 54
  expect_identical(
    warp_distance(y, period = "yweek", every = 1, origin = origin),
    c(51, 52, 52, 53, 53, 53, 54)
  )

  # 2000-03-01 -> 2001-02-21 = 51 full weeks
  # [2001-02-21, 2001-02-28) = 104
  # [2001-02-28, 2001-03-01) = 105
  # [2001-03-01, 2001-03-08) = 106
  # [2001-03-08, 2001-03-15) = 107
  expect_identical(
    warp_distance(z, period = "yweek", every = 1, origin = origin),
    c(104, 105, 106, 106, 106, 107)
  )
})

test_that("leap years in `origin` affect the yweek group", {
  origin <- as.Date("2000-03-01")

  x <- as.Date(c(
    "1999-02-27",
    "1999-02-28",
    "1999-03-01",
    "1999-03-02",
    "1999-03-07",
    "1999-03-08"
  ))
  y <- as.Date(c(
    "2000-02-27",
    "2000-02-28",
    "2000-02-29",
    "2000-03-01",
    "2000-03-02",
    "2000-03-07",
    "2000-03-08"
  ))
  z <- as.Date(c(
    "2001-02-27",
    "2001-02-28",
    "2001-03-01",
    "2001-03-02",
    "2001-03-07",
    "2001-03-08"
  ))

  # 1998-03-01 -> 1999-02-21 = 51 full weeks
  # [1999-02-21, 1999-02-28) = -55
  # [1999-02-28, 1999-03-01) = -54
  # [1999-03-01, 1999-03-08) = -53
  # [1999-03-08, 1999-03-15) = -52
  expect_identical(
    warp_distance(x, period = "yweek", every = 1, origin = origin),
    c(-55, -54, -53, -53, -53, -52)
  )

  # 1999-03-01 -> 2000-02-21 = 51 full weeks
  # [2000-02-21, 2000-02-28) = -2
  # [2000-02-28, 2000-03-01) = -1
  # [2000-03-01, 2000-03-08) = 0
  # [2000-03-08, 2000-03-15) = 1
  expect_identical(
    warp_distance(y, period = "yweek", every = 1, origin = origin),
    c(-2, -1, -1, 0, 0, 0, 1)
  )

  # 2000-03-01 -> 2001-02-21 = 51 full weeks
  # [2001-02-21, 2001-02-28) = 104
  # [2001-02-28, 2001-03-01) = 105
  # [2001-03-01, 2001-03-08) = 106
  # [2001-03-08, 2001-03-15) = 107
  expect_identical(
    warp_distance(z, period = "yweek", every = 1, origin = origin),
    c(51, 52, 53, 53, 53, 54)
  )
})

test_that("`origin` value can be on the leap day", {
  origin <- as.Date("2000-02-29")

  # Non-leap years start that group on 02/28
  x <- as.Date(c(
    "1999-02-27",
    "1999-02-28",
    "1999-03-01",
    "1999-03-02",
    "1999-03-07",
    "1999-03-08"
  ))
  y <- as.Date(c(
    "2000-02-27",
    "2000-02-28",
    "2000-02-29",
    "2000-03-01",
    "2000-03-02",
    "2000-03-07",
    "2000-03-08"
  ))
  z <- as.Date(c(
    "2001-02-27",
    "2001-02-28",
    "2001-03-01",
    "2001-03-02",
    "2001-03-07",
    "2001-03-08"
  ))

  # 1998-02-28 -> 1999-02-27 = 52 full weeks
  # [1999-02-27, 1999-02-28) = -54
  # [1999-02-28, 1999-03-07) = -53
  # [1999-03-07, 1999-03-15) = -52
  expect_identical(
    warp_distance(x, period = "yweek", every = 1, origin = origin),
    c(-54, -53, -53, -53, -52, -52)
  )

  # 1999-02-28 -> 2000-02-27 = 52 full weeks
  # [2000-02-27, 2000-02-29) = -1
  # [2000-02-29, 2000-03-07) = 0
  # [2000-03-07, 2000-03-15) = 1
  expect_identical(
    warp_distance(y, period = "yweek", every = 1, origin = origin),
    c(-1, -1, 0, 0, 0, 1, 1)
  )

  # 2000-02-29 -> 2001-02-27 = 52 full weeks
  # [2001-02-27, 2001-02-28) = 52
  # [2001-02-28, 2001-03-07) = 53
  # [2001-03-07, 2001-03-15) = 54
  expect_identical(
    warp_distance(z, period = "yweek", every = 1, origin = origin),
    c(52, 53, 53, 53, 54, 54)
  )
})

test_that("Ignoring the leap adjustment if before Feb 28th is required", {
  origin <- as.Date("1970-01-01")
  x <- as.Date(c("2019-12-31", "2020-01-01"))

  # if we don't ignore the leap adjustment we end up with both at 2649
  expect_identical(warp_distance(x, "yweek", origin = origin), c(2649, 2650))
})

test_that("sanity check `every`", {
  expect_error(
    warp_distance(as.Date("1970-01-01"), "yweek", every = 53),
    "is 52"
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "yweek")

test_that("can warp_distance() by yweek with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "yweek"), 0)

  x <- as.POSIXct("1970-01-08", tz = "UTC")
  expect_identical(warp_distance(x, "yweek"), 1)
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "yweek"), NA)

  expect_identical(warp_distance(x, "yweek"), 53)
  expect_identical(warp_distance(x, "yweek", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "yweek", origin = origin1), NA)

  expect_identical(warp_distance(x, "yweek", origin = origin1), 0)
  expect_identical(warp_distance(x, "yweek", origin = origin2), -53)
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "yweek", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "yweek", origin = origin))
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971-01
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "yweek", origin = origin)
    })
    expect_identical(out, 0)
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "yweek"), -1)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "yweek"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "yweek"), NA_real_)
})

test_that("can handle `every` with default origin", {
  x <- as.POSIXct(
    c(
      "1969-12-02",
      "1969-12-09",
      "1969-12-16",
      "1969-12-23",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-08",
      "1970-01-15",
      "1970-01-22"
    ),
    tz = "UTC"
  )

  expect_equal(
    warp_distance(x, period = "yweek", every = 2L),
    c(-4, -3, -3, -2, -2, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 3L),
    c(-3, -2, -2, -2, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 4L),
    c(-3, -2, -2, -2, -2, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin", {
  x <- as.POSIXct(
    c(
      "1969-12-02",
      "1969-12-09",
      "1969-12-16",
      "1969-12-23",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-06",
      "1970-01-07",
      "1970-01-08",
      "1970-01-15",
      "1970-01-22"
    ),
    tz = "UTC"
  )

  origin <- as.Date("1970-01-08")

  expect_equal(
    warp_distance(x, period = "yweek", every = 2L, origin = origin),
    c(-4, -4, -3, -3, -2, -2, -2, -2, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 3L, origin = origin),
    c(-3, -3, -2, -2, -2, -1, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 4L, origin = origin),
    c(-3, -3, -2, -2, -2, -2, -2, -2, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin and altered timezone", {
  x <- as.POSIXct(
    c(
      "1969-12-02",
      "1969-12-09",
      "1969-12-16",
      "1969-12-23",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-06",
      "1970-01-07",
      "1970-01-08",
      "1970-01-15",
      "1970-01-22"
    ),
    tz = "America/New_York"
  )

  origin <- as.POSIXct("1970-01-08", tz = "America/New_York")

  expect_equal(
    warp_distance(x, period = "yweek", every = 2L, origin = origin),
    c(-4, -4, -3, -3, -2, -2, -2, -2, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 3L, origin = origin),
    c(-3, -3, -2, -2, -2, -1, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "yweek", every = 4L, origin = origin),
    c(-3, -3, -2, -2, -2, -2, -2, -2, -1, 0, 0, 0)
  )
})

test_that("going backwards in time still uses groups computed from the first of the year", {
  # The 53rd yweek of 1969
  x <- as.POSIXct("1969-12-31", "UTC")
  # The 52nd yweek of 1969
  y <- as.POSIXct("1969-12-30", "UTC")
  expect_identical(warp_distance(x, "yweek"), -1)
  expect_identical(warp_distance(y, "yweek"), -2)
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "yweek"),
    warp_distance(y, period = "yweek")
  )
})

test_that("`origin` value can be on the leap day", {
  origin <- as.POSIXct("2000-02-29", "UTC")

  # Non-leap years start that group on 02/28
  x <- as.POSIXct(
    c(
      "1999-02-27",
      "1999-02-28",
      "1999-03-01",
      "1999-03-02",
      "1999-03-07",
      "1999-03-08"
    ),
    "UTC"
  )
  y <- as.POSIXct(
    c(
      "2000-02-27",
      "2000-02-28",
      "2000-02-29",
      "2000-03-01",
      "2000-03-02",
      "2000-03-07",
      "2000-03-08"
    ),
    "UTC"
  )
  z <- as.POSIXct(
    c(
      "2001-02-27",
      "2001-02-28",
      "2001-03-01",
      "2001-03-02",
      "2001-03-07",
      "2001-03-08"
    ),
    "UTC"
  )

  # 1998-02-28 -> 1999-02-27 = 52 full weeks
  # [1999-02-27, 1999-02-28) = -54
  # [1999-02-28, 1999-03-07) = -53
  # [1999-03-07, 1999-03-15) = -52
  expect_identical(
    warp_distance(x, period = "yweek", every = 1, origin = origin),
    c(-54, -53, -53, -53, -52, -52)
  )

  # 1999-02-28 -> 2000-02-27 = 52 full weeks
  # [2000-02-27, 2000-02-29) = -1
  # [2000-02-29, 2000-03-07) = 0
  # [2000-03-07, 2000-03-15) = 1
  expect_identical(
    warp_distance(y, period = "yweek", every = 1, origin = origin),
    c(-1, -1, 0, 0, 0, 1, 1)
  )

  # 2000-02-29 -> 2001-02-27 = 52 full weeks
  # [2001-02-27, 2001-02-28) = 52
  # [2001-02-28, 2001-03-07) = 53
  # [2001-03-07, 2001-03-15) = 54
  expect_identical(
    warp_distance(z, period = "yweek", every = 1, origin = origin),
    c(52, 53, 53, 53, 54, 54)
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "yweek")

test_that("can warp_distance() by yweek with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "yweek"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "yweek"), 53)
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "mweek")

# Mainly tested in `period = "mday"`

test_that("warp_distance() with mweek period works", {
  x <- as.Date("1970-01-01") + 0:500

  expect_identical(
    warp_distance(x, "mweek"),
    warp_distance(x, "mday", every = 7)
  )
})

test_that("sanity check `every`", {
  expect_error(warp_distance(new_date(0), "mweek", every = 5), "is 4")
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "week")

# Mainly tested in `period = "day"`

test_that("warp_distance() with week period works through day", {
  x <- as.Date("1970-01-01") + 0:500

  expect_identical(
    warp_distance(x, "week"),
    warp_distance(x, "day", every = 7)
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "yday")

# Mainly tested in `period = "yweek"`

test_that("warp_distance() with yday period works", {
  x <- as.Date("1970-01-01") + 0:500

  expect_identical(
    warp_distance(x, "yday", every = 7),
    warp_distance(x, "yweek")
  )
})

test_that("sanity check `every`", {
  expect_error(warp_distance(new_date(0), "yday", every = 365), "is 364")
})

test_that("can use an integer Date origin with yday", {
  origin <- structure(1L, class = "Date")
  expect_identical(warp_distance(new_date(0), "yday", origin = origin), -1)
})

test_that("integer Date origin that is NA is an error", {
  origin <- structure(NA_integer_, class = "Date")
  expect_error(
    warp_distance(new_date(0), "yday", origin = origin),
    "cannot be `NA`"
  )
})

test_that("double Date origin that is NA / NaN / Inf is an error", {
  origin <- structure(NA_real_, class = "Date")
  expect_error(
    warp_distance(new_date(0), "yday", origin = origin),
    "must be finite"
  )

  origin <- structure(NaN, class = "Date")
  expect_error(
    warp_distance(new_date(0), "yday", origin = origin),
    "must be finite"
  )

  origin <- structure(Inf, class = "Date")
  expect_error(
    warp_distance(new_date(0), "yday", origin = origin),
    "must be finite"
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "mday")

test_that("can warp_distance() by mday with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "mday"), warp_distance(x, "day"))

  x <- as.Date("1970-01-08")
  expect_identical(warp_distance(x, "mday"), warp_distance(x, "day"))

  x <- as.Date("1971-01-01")
  expect_identical(warp_distance(x, "mday"), warp_distance(x, "day"))
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "mday", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "mday", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "mday", origin = origin))
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "mday"), 0)

  x <- structure(31L, class = "Date")
  expect_identical(warp_distance(x, "mday"), 31)
})

test_that("leap year borders are handled correctly", {
  x <- as.Date(c("1968-12-31", "1969-01-01"))
  origin <- as.Date("1969-01-01")

  expect_equal(warp_distance(x, "mday", every = 2, origin = origin), c(-1, 0))
})

test_that("can handle `every` with default origin", {
  x <- as.Date(c(
    "1968-12-31",
    "1969-01-01",
    "1969-11-30",
    "1969-12-01",
    "1969-12-28",
    "1969-12-29",
    "1969-12-30",
    "1969-12-31",
    "1970-01-01",
    "1970-01-02",
    "1970-01-03"
  ))

  expect_equal(
    warp_distance(x, period = "mday", every = 2L),
    c(-187, -186, -17, -16, -3, -2, -2, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 3L),
    c(-128, -127, -12, -11, -2, -2, -2, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 4L),
    c(-96, -95, -9, -8, -2, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin", {
  x <- as.Date(c(
    "1968-12-31",
    "1969-01-01",
    "1969-11-30",
    "1969-12-01",
    "1969-12-28",
    "1969-12-29",
    "1969-12-30",
    "1969-12-31",
    "1970-01-01",
    "1970-01-02",
    "1970-01-03"
  ))

  origin <- as.Date("1969-12-01")

  expect_equal(
    warp_distance(x, period = "mday", every = 2L, origin = origin),
    c(-171, -170, -1, 0, 13, 14, 14, 15, 16, 16, 17)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 3L, origin = origin),
    c(-117, -116, -1, 0, 9, 9, 9, 10, 11, 11, 11)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 4L, origin = origin),
    c(-88, -87, -1, 0, 6, 7, 7, 7, 8, 8, 8)
  )
})

test_that("fractional Date pieces are ignored", {
  # "1969-12-31 23:59:52 UTC"
  # .POSIXct(-0.0001 * 86400, "UTC")
  x <- structure(-0.0001, class = "Date")

  # But we really treat this as `new_date(0)`
  expect_equal(warp_distance(x, period = "mday"), 0)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_equal(warp_distance(x, period = "mday"), numeric())
  expect_equal(warp_distance(x, period = "mday", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_equal(warp_distance(x, period = "mday"), numeric())
  expect_equal(warp_distance(x, period = "mday", every = 2), numeric())
})

test_that("going backwards in time still uses groups computed from the first of the year", {
  # The 53rd mday of 1969
  x <- as.Date("1969-12-31")
  # The 52nd mday of 1969
  y <- as.Date("1969-12-30")
  expect_identical(warp_distance(x, "mday"), -1)
  expect_identical(warp_distance(y, "mday"), -2)
})

test_that("sanity check `every`", {
  expect_error(
    warp_distance(as.Date("1970-01-01"), "mday", every = 31),
    "is 30"
  )
})

test_that("can use an integer Date origin with mday", {
  origin <- structure(-1L, class = "Date")
  expect_identical(warp_distance(new_date(0), "mday", origin = origin), 31)
})

test_that("integer Date origin that is NA is an error", {
  origin <- structure(NA_integer_, class = "Date")
  expect_error(
    warp_distance(new_date(0), "mday", origin = origin),
    "cannot be `NA`"
  )
})

test_that("double Date origin that is NA / NaN / Inf is an error", {
  origin <- structure(NA_real_, class = "Date")
  expect_error(
    warp_distance(new_date(0), "mday", origin = origin),
    "must be finite"
  )

  origin <- structure(NaN, class = "Date")
  expect_error(
    warp_distance(new_date(0), "mday", origin = origin),
    "must be finite"
  )

  origin <- structure(Inf, class = "Date")
  expect_error(
    warp_distance(new_date(0), "mday", origin = origin),
    "must be finite"
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "mday")

test_that("can warp_distance() by mday with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "mday"), warp_distance(x, "day"))

  x <- as.POSIXct("1970-01-08", tz = "UTC")
  expect_identical(warp_distance(x, "mday"), warp_distance(x, "day"))
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "mday"), NA)

  expect_identical(warp_distance(x, "mday"), 365)
  expect_identical(warp_distance(x, "mday", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "mday", origin = origin1), NA)

  expect_identical(warp_distance(x, "mday", origin = origin1), 0)
  expect_identical(warp_distance(x, "mday", origin = origin2), -365)
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "mday", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "mday", origin = origin))
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971-01
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "mday", origin = origin)
    })
    expect_identical(out, 0)
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "mday"), -1)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "mday"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "mday"), NA_real_)
})

test_that("can handle `every` with default origin", {
  x <- as.POSIXct(
    c(
      "1968-12-31",
      "1969-01-01",
      "1969-11-30",
      "1969-12-01",
      "1969-12-28",
      "1969-12-29",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-02",
      "1970-01-03"
    ),
    tz = "UTC"
  )

  expect_equal(
    warp_distance(x, period = "mday", every = 2L),
    c(-187, -186, -17, -16, -3, -2, -2, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 3L),
    c(-128, -127, -12, -11, -2, -2, -2, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 4L),
    c(-96, -95, -9, -8, -2, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin", {
  x <- as.POSIXct(
    c(
      "1968-12-31",
      "1969-01-01",
      "1969-11-30",
      "1969-12-01",
      "1969-12-28",
      "1969-12-29",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-02",
      "1970-01-03"
    ),
    tz = "UTC"
  )

  origin <- as.POSIXct("1969-12-01", "UTC")

  expect_equal(
    warp_distance(x, period = "mday", every = 2L, origin = origin),
    c(-171, -170, -1, 0, 13, 14, 14, 15, 16, 16, 17)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 3L, origin = origin),
    c(-117, -116, -1, 0, 9, 9, 9, 10, 11, 11, 11)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 4L, origin = origin),
    c(-88, -87, -1, 0, 6, 7, 7, 7, 8, 8, 8)
  )
})

test_that("can handle `every` with altered origin and altered timezone", {
  x <- as.POSIXct(
    c(
      "1968-12-31",
      "1969-01-01",
      "1969-11-30",
      "1969-12-01",
      "1969-12-28",
      "1969-12-29",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-02",
      "1970-01-03"
    ),
    tz = "America/New_York"
  )

  origin <- as.POSIXct("1969-12-01", tz = "America/New_York")

  expect_equal(
    warp_distance(x, period = "mday", every = 2L, origin = origin),
    c(-171, -170, -1, 0, 13, 14, 14, 15, 16, 16, 17)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 3L, origin = origin),
    c(-117, -116, -1, 0, 9, 9, 9, 10, 11, 11, 11)
  )
  expect_equal(
    warp_distance(x, period = "mday", every = 4L, origin = origin),
    c(-88, -87, -1, 0, 6, 7, 7, 7, 8, 8, 8)
  )
})

test_that("going backwards in time still uses groups computed from the first of the year", {
  # The 53rd mday of 1969
  x <- as.POSIXct("1969-12-31", "UTC")
  # The 52nd mday of 1969
  y <- as.POSIXct("1969-12-30", "UTC")
  expect_identical(warp_distance(x, "mday"), -1)
  expect_identical(warp_distance(y, "mday"), -2)
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "mday"),
    warp_distance(y, period = "mday")
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "mday")

test_that("can warp_distance() by mday with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "mday"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "mday"), 365)
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "day")

test_that("can warp_distance() by day with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "day"), 0)

  x <- as.Date("1970-01-02")
  expect_identical(warp_distance(x, "day"), 1)

  x <- as.Date("1971-01-01")
  expect_identical(warp_distance(x, "day"), 365)
})

test_that("can warp_distance() by day with 'negative' Dates", {
  x <- as.Date("1969-12-31")
  expect_identical(warp_distance(x, "day"), -1)

  x <- as.Date("1969-12-30")
  expect_identical(warp_distance(x, "day"), -2)
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "day", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "day", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "day", origin = origin))
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "day"), 0)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, class = "Date")
  expect_identical(warp_distance(x, "day"), NA_real_)

  x <- structure(NA_integer_, class = "Date")
  expect_identical(warp_distance(x, "day"), NA_real_)
})

test_that("can handle `every` with default origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  expect_equal(
    warp_distance(x, period = "day", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "day", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  expect_equal(
    warp_distance(x, period = "day", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "day", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("fractional Date pieces are ignored", {
  # "1969-12-31 23:59:52 UTC"
  # .POSIXct(-0.0001 * 86400, "UTC")
  x <- structure(-0.0001, class = "Date")

  # But we really treat this as `new_date(0)`
  expect_equal(warp_distance(x, period = "day"), 0)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_equal(warp_distance(x, period = "day"), numeric())
  expect_equal(warp_distance(x, period = "day", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_equal(warp_distance(x, period = "day"), numeric())
  expect_equal(warp_distance(x, period = "day", every = 2), numeric())
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "day")

test_that("can warp_distance() by day with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "day"), 0)

  x <- as.POSIXct("1970-01-02", tz = "UTC")
  expect_identical(warp_distance(x, "day"), 1)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "day"), 365)
})

# In terms of inclusion/exclusion, we define the cutoffs like:
# [1969-12-30 00:00:00 -> 1969-12-31 00:00:00) = -2 days from epoch
# [1969-12-31 00:00:00 -> 1970-01-01 00:00:00) = -1 days from epoch
# [1970-01-01 00:00:00 -> 1970-01-02 00:00:00) = 0 days from epoch
# [1970-01-02 00:00:00 -> 1970-01-03 00:00:00) = 1 days from epoch
test_that("can warp_distance() by day with 'negative' POSIXct", {
  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "day"), -2)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "day"), -2)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "day"), -1)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "day"), -1)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "day"), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "day"), 0)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "day"), 1)

  x <- as.POSIXct("1969-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "day"), -365)

  x <- as.POSIXct("1968-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "day"), -366)
})

test_that("can warp_distance() by day with 'negative' POSIXct and different UTC origins", {
  origin <- as.POSIXct("1969-12-31", tz = "UTC")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "day", origin = origin), -1)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "day", origin = origin), -1)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "day", origin = origin), 0)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "day", origin = origin), 0)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "day", origin = origin), 1)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "day", origin = origin), 1)
})

test_that("can warp_distance() by day with 'negative' POSIXct and non-UTC origins", {
  origin <- as.POSIXct("1970-01-01", tz = "America/New_York")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "day", origin = origin), -2)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "day", origin = origin), -2)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "day", origin = origin), -1)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "day", origin = origin), -1)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "day", origin = origin), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "day", origin = origin), 0)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "day", origin = origin), 1)
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "day"), NA)

  expect_identical(warp_distance(x, "day"), 365)
  expect_identical(warp_distance(x, "day", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "day", origin = origin1), NA)

  expect_identical(warp_distance(x, "day", origin = origin1), 0)
  expect_identical(warp_distance(x, "day", origin = origin2), -365)
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "day", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "day", origin = origin))
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971-01-01
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "day", origin = origin)
    })
    expect_identical(out, 0)
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "day"), -1)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "day"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "day"), NA_real_)
})

test_that("can handle `every` with default origin - integer POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-29",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-02",
      "1970-01-03",
      "1970-01-04"
    ),
    tz = "UTC"
  )

  x <- structure(as.integer(unclass(x)), tzone = "UTC", class = class(x))

  expect_equal(
    warp_distance(x, period = "day", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-29",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-02",
      "1970-01-03",
      "1970-01-04"
    ),
    tz = "UTC"
  )

  x <- structure(as.integer(unclass(x)), tzone = "UTC", class = class(x))

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "day", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-29",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-02",
      "1970-01-03",
      "1970-01-04"
    ),
    tz = "UTC"
  )

  expect_equal(
    warp_distance(x, period = "day", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-29",
      "1969-12-30",
      "1969-12-31",
      "1970-01-01",
      "1970-01-02",
      "1970-01-03",
      "1970-01-04"
    ),
    tz = "UTC"
  )

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "day", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "day", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("fractional negative seconds are handled correctly", {
  # Since we don't test all R-devel versions in CI, lets be extra safe here and
  # just not run this on CRAN
  skip_on_cran()
  skip_if(
    getRversion() < "4.4.0",
    "Used to be broken on everything except Linux"
  )

  # `as.POSIXlt()` was wrong on (except on Linux, I think) until this was fixed:
  # https://bugs.r-project.org/bugzilla/show_bug.cgi?id=17667

  # If working correctly, this should print as:
  # "1969-12-31T23:59:59.5"
  x <- .POSIXct(-0.5, "UTC")

  # This is
  # "1969-12-30T23:59:59.5"
  y <- .POSIXct(-86400.5, "UTC")

  # `as.POSIXlt()` used to give the wrong result by ignoring the negative
  # fractional part
  expect_identical(warp_distance(x, "day"), -1)
  expect_identical(warp_distance(y, "day"), -2)
})

test_that("DST is respected", {
  origin <- as.POSIXct("2018-03-11", "America/New_York")
  x <- as.POSIXct("2018-03-11 01:59:59", "America/New_York")

  # `x + 1` crosses the DST gap, so this day actually has 1 less hour.
  # We ensure that the 23:59:59 hour does not look like it has creeped into
  # the next day. If we used the pure POSIXct seconds, ignoring the time zone,
  # then we would have a problem!
  x <- x + c(0:1, 75600, 75601)

  expect_equal(warp_distance(x, "day", origin = origin), c(0, 0, 0, 1))
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "day"),
    warp_distance(y, period = "day")
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "day")

test_that("can warp_distance() by day with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "day"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "day"), 365)
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "hour")

test_that("can warp_distance() by hour with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "hour"), 0)

  x <- as.Date("1970-01-02")
  expect_identical(warp_distance(x, "hour"), 24)

  x <- as.Date("1971-01-01")
  expect_identical(warp_distance(x, "hour"), 24 * 365)
})

test_that("can warp_distance() by hour with 'negative' Dates", {
  x <- as.Date("1969-12-31")
  expect_identical(warp_distance(x, "hour"), -24)

  x <- as.Date("1969-12-30")
  expect_identical(warp_distance(x, "hour"), -48)
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "hour", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  # America/New_York is 5 hours before UTC
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "hour", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "hour", origin = origin))
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "hour"), 0)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, class = "Date")
  expect_identical(warp_distance(x, "hour"), NA_real_)

  x <- structure(NA_integer_, class = "Date")
  expect_identical(warp_distance(x, "hour"), NA_real_)
})

test_that("can handle `every` with default origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  expect_equal(
    warp_distance(x, period = "hour", every = 48L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 72L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 96L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "hour", every = 48L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 72L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 96L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  expect_equal(
    warp_distance(x, period = "hour", every = 48L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 72L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 96L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "hour", every = 48L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 72L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 96L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can ignore fractional pieces in Dates", {
  # "1970-01-01 02:24:00 UTC"
  # structure(.1 * 86400, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  x <- structure(.1, class = "Date")

  # "1969-12-31 23:52:48 UTC"
  # structure(-.005 * 86400, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.005, class = "Date")

  expect_identical(warp_distance(x, period = "hour"), 0)
  expect_identical(warp_distance(y, period = "hour"), 0)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_identical(warp_distance(x, period = "hour"), numeric())
  expect_identical(warp_distance(x, period = "hour", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_identical(warp_distance(x, period = "hour"), numeric())
  expect_identical(warp_distance(x, period = "hour", every = 2), numeric())
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "hour")

test_that("can warp_distance() by hour with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), 0)

  x <- as.POSIXct("1970-01-02", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), 24)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), 24 * 365)
})

# In terms of inclusion/exclusion, we define the cutoffs like:
# [1969-12-30 00:00:00 -> 1969-12-31 00:00:00) = -48 hours from epoch
# [1969-12-31 00:00:00 -> 1970-01-01 00:00:00) = -24 hours from epoch
# [1970-01-01 00:00:00 -> 1970-01-02 00:00:00) = 0 hours from epoch
# [1970-01-02 00:00:00 -> 1970-01-03 00:00:00) = 24 hours from epoch
test_that("can warp_distance() by hour with 'negative' POSIXct", {
  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), -48)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), -25)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), -24)

  x <- as.POSIXct("1969-12-31 01:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), -23)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), -1)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), 23)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), 24)

  x <- as.POSIXct("1969-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), -8760)

  x <- as.POSIXct("1968-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "hour"), -8761)
})

test_that("can warp_distance() by hour with 'negative' POSIXct and different UTC origins", {
  origin <- as.POSIXct("1969-12-31", tz = "UTC")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour", origin = origin), -24)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "hour", origin = origin), -1)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour", origin = origin), 0)

  x <- as.POSIXct("1969-12-31 01:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour", origin = origin), 1)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "hour", origin = origin), 23)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "hour", origin = origin), 24)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "hour", origin = origin), 47)
})

test_that("can warp_distance() by hour with 'negative' POSIXct and non-UTC origins", {
  origin <- as.POSIXct("1970-01-01", tz = "America/New_York")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "hour", origin = origin), -48)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "hour", origin = origin), -25)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "hour", origin = origin), -24)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "hour", origin = origin), -1)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "hour", origin = origin), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "hour", origin = origin), 23)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "hour", origin = origin), 24)
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "hour"), NA)

  expect_identical(warp_distance(x, "hour"), 8760)
  expect_identical(warp_distance(x, "hour", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "hour", origin = origin1), NA)

  expect_identical(warp_distance(x, "hour", origin = origin1), 0)
  expect_identical(warp_distance(x, "hour", origin = origin2), -8760)
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "hour", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "hour", origin = origin))
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971-01-01 04:00:00
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "hour", origin = origin)
    })
    expect_identical(out, 4)
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "hour"), -1)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "hour"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "hour"), NA_real_)
})

test_that("can handle `every` with default origin - integer POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 21:00:00",
      "1969-12-31 22:00:00",
      "1969-12-31 23:00:00",
      "1970-01-01 00:00:00",
      "1970-01-01 01:00:00",
      "1970-01-01 02:00:00",
      "1970-01-01 03:00:00"
    ),
    tz = "UTC"
  )

  x <- structure(as.integer(unclass(x)), tzone = "UTC", class = class(x))

  expect_equal(
    warp_distance(x, period = "hour", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 21:00:00",
      "1969-12-31 22:00:00",
      "1969-12-31 23:00:00",
      "1970-01-01 00:00:00",
      "1970-01-01 01:00:00",
      "1970-01-01 02:00:00",
      "1970-01-01 03:00:00"
    ),
    tz = "UTC"
  )

  x <- structure(as.integer(unclass(x)), tzone = "UTC", class = class(x))

  origin <- as.POSIXct("1970-01-01 01:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "hour", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 21:00:00",
      "1969-12-31 22:00:00",
      "1969-12-31 23:00:00",
      "1970-01-01 00:00:00",
      "1970-01-01 01:00:00",
      "1970-01-01 02:00:00",
      "1970-01-01 03:00:00"
    ),
    tz = "UTC"
  )

  expect_equal(
    warp_distance(x, period = "hour", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 21:00:00",
      "1969-12-31 22:00:00",
      "1969-12-31 23:00:00",
      "1970-01-01 00:00:00",
      "1970-01-01 01:00:00",
      "1970-01-01 02:00:00",
      "1970-01-01 03:00:00"
    ),
    tz = "UTC"
  )

  origin <- as.POSIXct("1970-01-01 01:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "hour", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "hour", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle fractional seconds before the epoch correctly", {
  # Base R printing is wrong, because as.POSIXlt() is wrong
  # https://bugs.r-project.org/bugzilla/show_bug.cgi?id=17667

  # I don't care what base R prints this as, this is:
  # "1969-12-31T23:59:59.5"
  x <- .POSIXct(-0.5, "UTC")

  # This is
  # "1969-12-31T22:59:59.5"
  y <- .POSIXct(-3600.5, "UTC")

  expect_identical(warp_distance(x, "hour"), -1)
  expect_identical(warp_distance(y, "hour"), -2)
})

test_that("values past microseconds are ignored", {
  x <- structure(-.000002, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.0000002, tzone = "UTC", class = c("POSIXct", "POSIXt"))

  expect_equal(warp_distance(x, "hour"), -1)
  expect_equal(warp_distance(y, "hour"), 0)
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "hour"),
    warp_distance(y, period = "hour")
  )
})

test_that("half-hour offset time zones are correct (#13)", {
  chr <- c(
    "1970-01-01 00:00:00",
    "1970-01-01 00:50:00",
    "1970-01-01 01:00:00",
    "1970-01-01 01:20:00",
    "1970-01-01 01:30:00"
  )

  x <- as.POSIXct(chr, "Asia/Kolkata")
  y <- as.POSIXct(chr, "UTC")

  expect_equal(
    warp_distance(x, period = "hour"),
    warp_distance(y, period = "hour")
  )
})

test_that("can have an integer POSIXct origin", {
  x <- new_datetime(60 * 60, "UTC")

  origin <- structure(0L, tzone = "UTC", class = c("POSIXct", "POSIXt"))

  expect_identical(
    warp_distance(x, period = "hour", origin = origin),
    1
  )
})

test_that("integer Date `origin` cannot be NA_integer_", {
  x <- new_datetime(0, "UTC")
  origin <- structure(NA_integer_, class = "Date")
  expect_error(
    warp_distance(x, period = "hour", origin = origin),
    "`origin` must be finite"
  )
})

test_that("double Date `origin` cannot be NA_real_ / NaN / Inf", {
  x <- new_datetime(0, "UTC")

  origin <- structure(NA_real_, class = "Date")
  expect_error(
    warp_distance(x, period = "hour", origin = origin),
    "`origin` must be finite"
  )

  origin <- structure(NaN, class = "Date")
  expect_error(
    warp_distance(x, period = "hour", origin = origin),
    "`origin` must be finite"
  )

  origin <- structure(Inf, class = "Date")
  expect_error(
    warp_distance(x, period = "hour", origin = origin),
    "`origin` must be finite"
  )
})

test_that("double POSIXct `origin` cannot be NA_real_ / NaN / Inf", {
  x <- new_datetime(0, "UTC")

  origin <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_error(
    warp_distance(x, period = "hour", origin = origin),
    "`origin` must be finite"
  )

  origin <- structure(NaN, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_error(
    warp_distance(x, period = "hour", origin = origin),
    "`origin` must be finite"
  )

  origin <- structure(Inf, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_error(
    warp_distance(x, period = "hour", origin = origin),
    "`origin` must be finite"
  )
})

test_that("integer POSIXct `origin` cannot be NA_integer_", {
  x <- new_datetime(0, "UTC")

  origin <- structure(
    NA_integer_,
    tzone = "UTC",
    class = c("POSIXct", "POSIXt")
  )
  expect_error(
    warp_distance(x, period = "hour", origin = origin),
    "`origin` must be finite"
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "hour")

test_that("can warp_distance() by hour with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "hour"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "hour"), 8760)
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "minute")

test_that("can warp_distance() by minute with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "minute"), 0)

  x <- as.Date("1970-01-02")
  expect_identical(warp_distance(x, "minute"), 1440)

  x <- as.Date("1971-01-01")
  expect_identical(warp_distance(x, "minute"), 60 * 24 * 365)
})

test_that("can warp_distance() by minute with 'negative' Dates", {
  x <- as.Date("1969-12-31")
  expect_identical(warp_distance(x, "minute"), -1440)

  x <- as.Date("1969-12-30")
  expect_identical(warp_distance(x, "minute"), -1440 * 2)
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "minute", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  # America/New_York is 5 minutes before UTC
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "minute", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "minute", origin = origin))
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "minute"), 0)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, class = "Date")
  expect_identical(warp_distance(x, "minute"), NA_real_)

  x <- structure(NA_integer_, class = "Date")
  expect_identical(warp_distance(x, "minute"), NA_real_)
})

test_that("can handle `every` with default origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  expect_equal(
    warp_distance(x, period = "minute", every = 2880L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 4320L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 5760L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "minute", every = 2880L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 4320L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 5760L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  expect_equal(
    warp_distance(x, period = "minute", every = 2880L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 4320L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 5760L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "minute", every = 2880L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 4320L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 5760L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can ignore fractional pieces in Dates", {
  # "1970-01-01 00:07:12 UTC"
  # structure(.005 * 86400, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  x <- structure(.005, class = "Date")

  # "1969-12-31 23:52:48 UTC"
  # structure(-.005 * 86400, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.005, class = "Date")

  expect_identical(warp_distance(x, period = "minute"), 0)
  expect_identical(warp_distance(y, period = "minute"), 0)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_equal(warp_distance(x, period = "minute"), numeric())
  expect_equal(warp_distance(x, period = "minute", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_equal(warp_distance(x, period = "minute"), numeric())
  expect_equal(warp_distance(x, period = "minute", every = 2), numeric())
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "minute")

test_that("can warp_distance() by minute with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), 0)

  x <- as.POSIXct("1970-01-02", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), 1440)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), 60 * 24 * 365)
})

# In terms of inclusion/exclusion, we define the cutoffs like:
# [1969-12-30 00:00:00 -> 1969-12-31 00:00:00) = -2880 minutes from epoch
# [1969-12-31 00:00:00 -> 1970-01-01 00:00:00) = -1440 minutes from epoch
# [1970-01-01 00:00:00 -> 1970-01-02 00:00:00) = 0 minutes from epoch
# [1970-01-02 00:00:00 -> 1970-01-03 00:00:00) = 1440 minutes from epoch
test_that("can warp_distance() by minute with 'negative' POSIXct", {
  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), -2880)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), -1441)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), -1440)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), -1)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), 1439)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), 1440)

  x <- as.POSIXct("1969-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute"), -(60 * 24 * 365))
})

test_that("can warp_distance() by minute with 'negative' POSIXct and different UTC origins", {
  origin <- as.POSIXct("1969-12-31", tz = "UTC")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute", origin = origin), -1440)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "minute", origin = origin), -1)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute", origin = origin), 0)

  x <- as.POSIXct("1969-12-31 01:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute", origin = origin), 60)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "minute", origin = origin), 1439)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "minute", origin = origin), 1440)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "minute", origin = origin), 2880 - 1)
})

test_that("can warp_distance() by minute with 'negative' POSIXct and non-UTC origins", {
  origin <- as.POSIXct("1970-01-01", tz = "America/New_York")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "minute", origin = origin), -2880)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "minute", origin = origin), -1441)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "minute", origin = origin), -1440)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "minute", origin = origin), -1)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "minute", origin = origin), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "minute", origin = origin), 1439)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "minute", origin = origin), 1440)
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "minute"), NA)

  expect_identical(warp_distance(x, "minute"), 525600)
  expect_identical(warp_distance(x, "minute", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "minute", origin = origin1), NA)

  expect_identical(warp_distance(x, "minute", origin = origin1), 0)
  expect_identical(warp_distance(x, "minute", origin = origin2), -525600)
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  # America/New_York is 5 hours behind UTC, or 300 minutes
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "minute", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "minute", origin = origin))
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971-01-01 04:00:00
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "minute", origin = origin)
    })
    expect_identical(out, 240) # 4 hr * 60 min
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "minute"), -1)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "minute"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "minute"), NA_real_)
})

test_that("can handle `every` with default origin - integer POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:57:00",
      "1969-12-31 23:58:00",
      "1969-12-31 23:59:00",
      "1970-01-01 00:00:00",
      "1970-01-01 00:01:00",
      "1970-01-01 00:02:00",
      "1970-01-01 00:03:00"
    ),
    tz = "UTC"
  )

  x <- structure(as.integer(unclass(x)), tzone = "UTC", class = class(x))

  expect_equal(
    warp_distance(x, period = "minute", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:57:00",
      "1969-12-31 23:58:00",
      "1969-12-31 23:59:00",
      "1970-01-01 00:00:00",
      "1970-01-01 00:01:00",
      "1970-01-01 00:02:00",
      "1970-01-01 00:03:00"
    ),
    tz = "UTC"
  )

  x <- structure(as.integer(unclass(x)), tzone = "UTC", class = class(x))

  origin <- as.POSIXct("1970-01-01 00:01:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "minute", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:57:00",
      "1969-12-31 23:58:00",
      "1969-12-31 23:59:00",
      "1970-01-01 00:00:00",
      "1970-01-01 00:01:00",
      "1970-01-01 00:02:00",
      "1970-01-01 00:03:00"
    ),
    tz = "UTC"
  )

  expect_equal(
    warp_distance(x, period = "minute", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:57:00",
      "1969-12-31 23:58:00",
      "1969-12-31 23:59:00",
      "1970-01-01 00:00:00",
      "1970-01-01 00:01:00",
      "1970-01-01 00:02:00",
      "1970-01-01 00:03:00"
    ),
    tz = "UTC"
  )

  origin <- as.POSIXct("1970-01-01 00:01:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "minute", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "minute", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle fractional seconds before the epoch correctly", {
  # Base R printing is wrong, because as.POSIXlt() is wrong
  # https://bugs.r-project.org/bugzilla/show_bug.cgi?id=17667

  # I don't care what base R prints this as, this is:
  # "1969-12-31T23:59:59.5"
  x <- .POSIXct(-0.5, "UTC")

  # This is
  # "1969-12-31T22:59:59.5"
  y <- .POSIXct(-3600.5, "UTC")

  expect_identical(warp_distance(x, "minute"), -1)
  expect_identical(warp_distance(y, "minute"), -61)
})

test_that("`origin` could have fractional components - integer POSIXct", {
  origin <- as.POSIXct("1969-12-31 23:59:59.998", "UTC")
  x <- structure(
    c(-120L, -60L, 0L, 58L, 59L, 60L),
    tzone = "UTC",
    class = c("POSIXct", "POSIXt")
  )

  expect_identical(
    warp_distance(x, "minute", origin = origin),
    c(-2, -1, 0, 0, 1, 1)
  )
})

test_that("values past microseconds are essentially ignored", {
  x <- structure(-.000002, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.0000002, tzone = "UTC", class = c("POSIXct", "POSIXt"))

  expect_equal(warp_distance(x, "minute"), -1)
  expect_equal(warp_distance(y, "minute"), 0)
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "minute"),
    warp_distance(y, period = "minute")
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "minute")

test_that("can warp_distance() by minute with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "minute"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "minute"), 525600)
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "second")

test_that("can warp_distance() by second with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "second"), 0)

  x <- as.Date("1970-01-02")
  expect_identical(warp_distance(x, "second"), 86400)

  x <- as.Date("1971-01-01")
  expect_identical(warp_distance(x, "second"), 60 * 60 * 24 * 365)
})

test_that("can warp_distance() by second with 'negative' Dates", {
  x <- as.Date("1969-12-31")
  expect_identical(warp_distance(x, "second"), -86400)

  x <- as.Date("1969-12-30")
  expect_identical(warp_distance(x, "second"), -86400 * 2L)
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "second", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  # America/New_York is 5 seconds before UTC
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "second", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "second", origin = origin))
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "second"), 0)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, class = "Date")
  expect_identical(warp_distance(x, "second"), NA_real_)

  x <- structure(NA_integer_, class = "Date")
  expect_identical(warp_distance(x, "second"), NA_real_)
})

test_that("can handle `every` with default origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  expect_equal(
    warp_distance(x, period = "second", every = 172800),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 259200),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 345600),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "second", every = 172800, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 259200, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 345600, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  expect_equal(
    warp_distance(x, period = "second", every = 172800),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 259200),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 345600),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(x, period = "second", every = 172800, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 259200, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 345600, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can ignore fractional pieces in Dates", {
  # "1970-01-01 00:07:12 UTC"
  # structure(.005 * 86400, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  x <- structure(.005, class = "Date")

  # "1969-12-31 23:52:48 UTC"
  # structure(-.005 * 86400, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.005, class = "Date")

  expect_identical(warp_distance(x, period = "second"), 0)
  expect_identical(warp_distance(y, period = "second"), 0)
})

test_that("can handle second values larger than max int value", {
  x <- as.Date("2100-01-01")
  expect_equal(warp_distance(x, "second"), 4102444800)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_equal(warp_distance(x, period = "second"), numeric())
  expect_equal(warp_distance(x, period = "second", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_equal(warp_distance(x, period = "second"), numeric())
  expect_equal(warp_distance(x, period = "second", every = 2), numeric())
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "second")

test_that("can warp_distance() by second with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "second"), 0)

  x <- as.POSIXct("1970-01-02", tz = "UTC")
  expect_identical(warp_distance(x, "second"), 86400)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "second"), 60 * 60 * 24 * 365)
})

# In terms of inclusion/exclusion, we define the cutoffs like:
# [1969-12-30 00:00:00 -> 1969-12-31 00:00:00)
# [1969-12-31 00:00:00 -> 1970-01-01 00:00:00)
# [1970-01-01 00:00:00 -> 1970-01-02 00:00:00)
# [1970-01-02 00:00:00 -> 1970-01-03 00:00:00)
test_that("can warp_distance() by second with 'negative' POSIXct", {
  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second"), -172800)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "second"), -86401)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second"), -86400)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "second"), -1)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second"), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "second"), 86399)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second"), 86400)

  x <- as.POSIXct("1969-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second"), -(60 * 60 * 24 * 365))
})

test_that("can warp_distance() by second with 'negative' POSIXct and different UTC origins", {
  origin <- as.POSIXct("1969-12-31", tz = "UTC")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second", origin = origin), -86400)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "second", origin = origin), -1)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second", origin = origin), 0)

  x <- as.POSIXct("1969-12-31 01:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second", origin = origin), 3600)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "second", origin = origin), 86399)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "second", origin = origin), 86400)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "second", origin = origin), 172800 - 1)
})

test_that("can warp_distance() by second with 'negative' POSIXct and non-UTC origins", {
  origin <- as.POSIXct("1970-01-01", tz = "America/New_York")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "second", origin = origin), -172800)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "second", origin = origin), -86401)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "second", origin = origin), -86400)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "second", origin = origin), -1)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "second", origin = origin), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "second", origin = origin), 86399)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "second", origin = origin), 86400)
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "second"), NA)

  expect_identical(warp_distance(x, "second"), 31536000)
  expect_identical(warp_distance(x, "second", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "second", origin = origin1), NA)

  expect_identical(warp_distance(x, "second", origin = origin1), 0)
  expect_identical(warp_distance(x, "second", origin = origin2), -31536000)
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  # America/New_York is 5 hours behind UTC, or 300 seconds
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "second", origin = origin)
  })
  expect_identical(out, warp_distance(x_with_tz, "second", origin = origin))
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971-01-01 04:00:00
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "second", origin = origin)
    })
    expect_identical(out, 14400) # 4 hr * 60 min * 60 sec
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "second"), -1)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "second"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "second"), NA_real_)
})

test_that("can handle `every` with default origin - integer POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:59:57",
      "1969-12-31 23:59:58",
      "1969-12-31 23:59:59",
      "1970-01-01 00:00:00",
      "1970-01-01 00:00:01",
      "1970-01-01 00:00:02",
      "1970-01-01 00:00:03"
    ),
    tz = "UTC"
  )

  x <- structure(as.integer(unclass(x)), tzone = "UTC", class = class(x))

  expect_identical(
    warp_distance(x, period = "second", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_identical(
    warp_distance(x, period = "second", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_identical(
    warp_distance(x, period = "second", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:59:57",
      "1969-12-31 23:59:58",
      "1969-12-31 23:59:59",
      "1970-01-01 00:00:00",
      "1970-01-01 00:00:01",
      "1970-01-01 00:00:02",
      "1970-01-01 00:00:03"
    ),
    tz = "UTC"
  )

  x <- structure(as.integer(unclass(x)), tzone = "UTC", class = class(x))

  origin <- as.POSIXct("1970-01-01 00:00:01", tz = "UTC")

  expect_identical(
    warp_distance(x, period = "second", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_identical(
    warp_distance(x, period = "second", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_identical(
    warp_distance(x, period = "second", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:59:57",
      "1969-12-31 23:59:58",
      "1969-12-31 23:59:59",
      "1970-01-01 00:00:00",
      "1970-01-01 00:00:01",
      "1970-01-01 00:00:02",
      "1970-01-01 00:00:03"
    ),
    tz = "UTC"
  )

  expect_identical(
    warp_distance(x, period = "second", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_identical(
    warp_distance(x, period = "second", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_identical(
    warp_distance(x, period = "second", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:59:57",
      "1969-12-31 23:59:58",
      "1969-12-31 23:59:59",
      "1970-01-01 00:00:00",
      "1970-01-01 00:00:01",
      "1970-01-01 00:00:02",
      "1970-01-01 00:00:03"
    ),
    tz = "UTC"
  )

  origin <- as.POSIXct("1970-01-01 00:00:01", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "second", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "second", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle fractional seconds before the epoch correctly", {
  # Base R printing is wrong, because as.POSIXlt() is wrong
  # https://bugs.r-project.org/bugzilla/show_bug.cgi?id=17667

  # I don't care what base R prints this as, this is:
  # "1969-12-31T23:59:59.5"
  x <- .POSIXct(-0.5, "UTC")

  # This is
  # "1969-12-31T22:59:59.5"
  y <- .POSIXct(-3600.5, "UTC")

  expect_equal(warp_distance(x, "second"), -1)
  expect_equal(warp_distance(y, "second"), -3601)
})

test_that("can handle second values larger than max int value", {
  x <- as.POSIXct("2100-01-01", "UTC")
  expect_equal(warp_distance(x, "second"), 4102444800)
})

test_that("`origin` could have fractional components (ignore them) - integer POSIXct", {
  origin <- as.POSIXct("1969-12-31 23:59:59.998", "UTC")
  x <- structure(
    c(-2L, -1L, 0L, 1L),
    tzone = "UTC",
    class = c("POSIXct", "POSIXt")
  )

  expect_identical(warp_distance(x, "second", origin = origin), c(-1, 0, 1, 2))
})

test_that("values past microseconds are essentially ignored", {
  x <- structure(-.000002, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.0000002, tzone = "UTC", class = c("POSIXct", "POSIXt"))

  expect_equal(warp_distance(x, "second"), -1)
  expect_equal(warp_distance(y, "second"), 0)
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "second"),
    warp_distance(y, period = "second")
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "second")

test_that("can warp_distance() by second with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "second"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "second"), 31536000)
})

# ------------------------------------------------------------------------------
# warp_distance(<Date>, period = "millisecond")

test_that("can warp_distance() by millisecond with Date", {
  x <- as.Date("1970-01-01")
  expect_identical(warp_distance(x, "millisecond"), 0)

  x <- as.Date("1970-01-02")
  expect_identical(warp_distance(x, "millisecond"), 86400 * 1000)

  x <- as.Date("1971-01-01")
  expect_identical(warp_distance(x, "millisecond"), 60 * 60 * 24 * 365 * 1000)
})

test_that("can warp_distance() by millisecond with 'negative' Dates", {
  x <- as.Date("1969-12-31")
  expect_identical(warp_distance(x, "millisecond"), -86400 * 1000)

  x <- as.Date("1969-12-30")
  expect_identical(warp_distance(x, "millisecond"), -86400 * 2 * 1000)
})

test_that("Date + UTC origin does not emit a warning", {
  x <- as.Date("1971-01-01")
  origin <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_identical(warp_distance(x, "millisecond", origin = origin), 0)
})

test_that("Date + non-UTC origin converts with a warning", {
  # America/New_York is 5 milliseconds before UTC
  x <- as.Date("1971-01-01")
  x_with_tz <- structure(
    unclass(x) * 86400,
    tzone = "America/New_York",
    class = c("POSIXct", "POSIXt")
  )
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "millisecond", origin = origin)
  })
  expect_identical(
    out,
    warp_distance(x_with_tz, "millisecond", origin = origin)
  )
})

test_that("can use integer Dates", {
  x <- structure(0L, class = "Date")
  expect_identical(warp_distance(x, "millisecond"), 0)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, class = "Date")
  expect_identical(warp_distance(x, "millisecond"), NA_real_)

  x <- structure(NA_integer_, class = "Date")
  expect_identical(warp_distance(x, "millisecond"), NA_real_)
})

test_that("can handle `every` with default origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  expect_equal(
    warp_distance(x, period = "millisecond", every = 172800 * 1000),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "millisecond", every = 259200 * 1000),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "millisecond", every = 345600 * 1000),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - integer Dates", {
  x <- structure(-3L:3L, class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(
      x,
      period = "millisecond",
      every = 172800 * 1000,
      origin = origin
    ),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(
      x,
      period = "millisecond",
      every = 259200 * 1000,
      origin = origin
    ),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(
      x,
      period = "millisecond",
      every = 345600 * 1000,
      origin = origin
    ),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle `every` with default origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  expect_equal(
    warp_distance(x, period = "millisecond", every = 172800 * 1000),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_equal(
    warp_distance(x, period = "millisecond", every = 259200 * 1000),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "millisecond", every = 345600 * 1000),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric Dates", {
  x <- structure(as.numeric(-3:3), class = "Date")

  origin <- as.Date("1970-01-02")

  expect_equal(
    warp_distance(
      x,
      period = "millisecond",
      every = 172800 * 1000,
      origin = origin
    ),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(
      x,
      period = "millisecond",
      every = 259200 * 1000,
      origin = origin
    ),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(
      x,
      period = "millisecond",
      every = 345600 * 1000,
      origin = origin
    ),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can ignore fractional pieces in Dates", {
  # "1970-01-01T00:00:00.432 UTC"
  # structure(.000005 * 86400, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  x <- structure(.000005, class = "Date")

  # "1969-12-31T23:59:59.568 UTC"
  # structure(-.005 * 86400, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.000005, class = "Date")

  # "1970-01-02T00:00:00.432 UTC"
  z <- structure(1.000005, class = "Date")

  expect_identical(warp_distance(x, period = "millisecond"), 0)
  expect_identical(warp_distance(y, period = "millisecond"), 0)
  expect_identical(warp_distance(z, period = "millisecond"), 86400000)
})

test_that("can handle millisecond values larger than max int value", {
  x <- as.Date("2100-01-01")
  expect_equal(warp_distance(x, "millisecond"), 4102444800 * 1000)
})

test_that("size 0 input works - integer Dates", {
  x <- structure(integer(), class = "Date")

  expect_equal(warp_distance(x, period = "millisecond"), numeric())
  expect_equal(warp_distance(x, period = "millisecond", every = 2), numeric())
})

test_that("size 0 input works - numeric Dates", {
  x <- structure(numeric(), class = "Date")

  expect_equal(warp_distance(x, period = "millisecond"), numeric())
  expect_equal(warp_distance(x, period = "millisecond", every = 2), numeric())
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXct>, period = "millisecond")

test_that("can warp_distance() by millisecond with POSIXct", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), 0)

  x <- as.POSIXct("1970-01-02", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), 86400 * 1000)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), 60 * 60 * 24 * 365 * 1000)
})

# In terms of inclusion/exclusion, we define the cutoffs like:
# [1969-12-30 00:00:00 -> 1969-12-31 00:00:00)
# [1969-12-31 00:00:00 -> 1970-01-01 00:00:00)
# [1970-01-01 00:00:00 -> 1970-01-02 00:00:00)
# [1970-01-02 00:00:00 -> 1970-01-03 00:00:00)
test_that("can warp_distance() by millisecond with 'negative' POSIXct", {
  x <- as.POSIXct("1969-12-30 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), -172800 * 1000)

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), -86401 * 1000)

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), -86400 * 1000)

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), -1 * 1000)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), 86399 * 1000)

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "UTC")
  expect_identical(warp_distance(x, "millisecond"), 86400 * 1000)

  x <- as.POSIXct("1969-01-01 00:00:00", tz = "UTC")
  expect_identical(
    warp_distance(x, "millisecond"),
    -(60 * 60 * 24 * 365) * 1000
  )
})

test_that("can warp_distance() by millisecond with 'negative' POSIXct and non-UTC origins", {
  origin <- as.POSIXct("1970-01-01", tz = "America/New_York")

  x <- as.POSIXct("1969-12-30 00:00:00", tz = "America/New_York")
  expect_identical(
    warp_distance(x, "millisecond", origin = origin),
    -172800 * 1000
  )

  x <- as.POSIXct("1969-12-30 23:59:59", tz = "America/New_York")
  expect_identical(
    warp_distance(x, "millisecond", origin = origin),
    -86401 * 1000
  )

  x <- as.POSIXct("1969-12-31 00:00:00", tz = "America/New_York")
  expect_identical(
    warp_distance(x, "millisecond", origin = origin),
    -86400 * 1000
  )

  x <- as.POSIXct("1969-12-31 23:59:59", tz = "America/New_York")
  expect_identical(warp_distance(x, "millisecond", origin = origin), -1 * 1000)

  x <- as.POSIXct("1970-01-01 00:00:00", tz = "America/New_York")
  expect_identical(warp_distance(x, "millisecond", origin = origin), 0)

  x <- as.POSIXct("1970-01-01 23:59:59", tz = "America/New_York")
  expect_identical(
    warp_distance(x, "millisecond", origin = origin),
    86399 * 1000
  )

  x <- as.POSIXct("1970-01-02 00:00:00", tz = "America/New_York")
  expect_identical(
    warp_distance(x, "millisecond", origin = origin),
    86400 * 1000
  )
})

test_that("UTC POSIXct + UTC origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")

  expect_warning(warp_distance(x, "millisecond"), NA)

  expect_identical(warp_distance(x, "millisecond"), 31536000 * 1000)
  expect_identical(warp_distance(x, "millisecond", origin = x), 0)
})

test_that("UTC POSIXct + Date origin does not emit a warning", {
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  origin1 <- as.Date("1971-01-01")
  origin2 <- as.Date("1972-01-01")

  expect_warning(warp_distance(x, "millisecond", origin = origin1), NA)

  expect_identical(warp_distance(x, "millisecond", origin = origin1), 0)
  expect_identical(
    warp_distance(x, "millisecond", origin = origin2),
    -31536000 * 1000
  )
})

test_that("UTC POSIXct + non-UTC origin converts with a warning", {
  # America/New_York is 5 hours behind UTC, or 300 milliseconds
  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x_with_tz <- structure(x, tzone = "America/New_York")
  origin <- as.POSIXct("1971-01-01", tz = "America/New_York")

  expect_snapshot({
    out <- warp_distance(x, "millisecond", origin = origin)
  })
  expect_identical(
    out,
    warp_distance(x_with_tz, "millisecond", origin = origin)
  )
})

test_that("local time POSIXct + UTC origin converts with a warning", {
  with_envvar(list(TZ = "America/New_York"), {
    x <- as.POSIXct("1970-12-31 23:00:00") # in UTC this is in 1971-01-01 04:00:00
    origin <- as.POSIXct("1971-01-01", tz = "UTC")

    expect_snapshot({
      out <- warp_distance(x, "millisecond", origin = origin)
    })
    expect_identical(out, 14400 * 1000) # 4 hr * 60 min * 60 sec * 1000 milliseconds
  })
})

test_that("can use integer POSIXct", {
  x <- structure(-1L, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "millisecond"), -1 * 1000)
})

test_that("can handle `NA` dates", {
  x <- structure(NA_real_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "millisecond"), NA_real_)

  x <- structure(NA_integer_, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  expect_identical(warp_distance(x, "millisecond"), NA_real_)
})

test_that("can handle `every` with default origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:59:59.997",
      "1969-12-31 23:59:59.998",
      "1969-12-31 23:59:59.999",
      "1970-01-01 00:00:00.000",
      "1970-01-01 00:00:00.001",
      "1970-01-01 00:00:00.002",
      "1970-01-01 00:00:00.003"
    ),
    tz = "UTC"
  )

  expect_identical(
    warp_distance(x, period = "millisecond", every = 2L),
    c(-2, -1, -1, 0, 0, 1, 1)
  )
  expect_identical(
    warp_distance(x, period = "millisecond", every = 3L),
    c(-1, -1, -1, 0, 0, 0, 1)
  )
  expect_identical(
    warp_distance(x, period = "millisecond", every = 4L),
    c(-1, -1, -1, 0, 0, 0, 0)
  )
})

test_that("can handle `every` with altered origin - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:59:59.997",
      "1969-12-31 23:59:59.998",
      "1969-12-31 23:59:59.999",
      "1970-01-01 00:00:00.000",
      "1970-01-01 00:00:00.001",
      "1970-01-01 00:00:00.002",
      "1970-01-01 00:00:00.003"
    ),
    tz = "UTC"
  )

  origin <- as.POSIXct("1970-01-01 00:00:00.001", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "millisecond", every = 2L, origin = origin),
    c(-2, -2, -1, -1, 0, 0, 1)
  )
  expect_equal(
    warp_distance(x, period = "millisecond", every = 3L, origin = origin),
    c(-2, -1, -1, -1, 0, 0, 0)
  )
  expect_equal(
    warp_distance(x, period = "millisecond", every = 4L, origin = origin),
    c(-1, -1, -1, -1, 0, 0, 0)
  )
})

test_that("can handle fractional pieces with decimilliseconds correctly", {
  x <- as.POSIXct("1969-12-31 23:59:59.9989", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), -2)

  x <- as.POSIXct("1969-12-31 23:59:59.9995", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), -1)

  x <- as.POSIXct("1969-12-31 23:59:59.9999", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), -1)

  x <- as.POSIXct("1970-01-01 00:00:00.0000", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), 0)

  x <- as.POSIXct("1970-01-01 00:00:00.0009", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), 0)

  x <- as.POSIXct("1970-01-01 00:00:00.0010", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), 1)

  x <- as.POSIXct("1970-01-01 00:00:00.0011", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), 1)
})

test_that("can handle fractional pieces with centimilliseconds correctly", {
  # Base R is going to print these wrong, use {nanotime} if you need to
  # print them correctly
  x <- as.POSIXct("1969-12-31 23:59:59.99809", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), -2)

  x <- as.POSIXct("1969-12-31 23:59:59.99905", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), -1)

  x <- as.POSIXct("1969-12-31 23:59:59.99909", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), -1)

  x <- as.POSIXct("1970-01-01 00:00:00.00000", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), 0)

  x <- as.POSIXct("1970-01-01 00:00:00.00009", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), 0)

  x <- as.POSIXct("1970-01-01 00:00:00.00100", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), 1)

  x <- as.POSIXct("1970-01-01 00:00:00.00101", "UTC")
  expect_identical(warp_distance(x, period = "millisecond"), 1)
})

test_that("`origin` could have floating point error values that need guarding - numeric POSIXct", {
  x <- as.POSIXct(
    c(
      "1969-12-31 23:59:59.997",
      "1969-12-31 23:59:59.998",
      "1969-12-31 23:59:59.999",
      "1970-01-01 00:00:00.000",
      "1970-01-01 00:00:00.001",
      "1970-01-01 00:00:00.002",
      "1970-01-01 00:00:00.003"
    ),
    tz = "UTC"
  )

  # We know this one can't be represented exactly in floating point
  origin <- as.POSIXct("1969-12-31 23:59:59.998", "UTC")

  expect_identical(
    warp_distance(x, period = "millisecond", every = 1L, origin = origin),
    c(-1, 0, 1, 2, 3, 4, 5)
  )
  expect_identical(
    warp_distance(x, period = "millisecond", every = 2L, origin = origin),
    c(-1, 0, 0, 1, 1, 2, 2)
  )
})

test_that("`origin` could have floating point error values that need guarding - integer POSIXct", {
  # "1970-01-01 00:00:00 UTC" "1969-12-31 23:59:59 UTC"
  x <- structure(c(0L, -1L), tzone = "UTC", class = c("POSIXct", "POSIXt"))

  # We know this one can't be represented exactly in floating point
  origin <- as.POSIXct("1969-12-31 23:59:59.998", "UTC")

  expect_identical(
    warp_distance(x, period = "millisecond", every = 1L, origin = origin),
    c(2, -998)
  )
})

test_that("values past microseconds are essentially ignored", {
  x <- structure(-.000002, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.0000002, tzone = "UTC", class = c("POSIXct", "POSIXt"))

  expect_equal(warp_distance(x, "millisecond"), -1)
  expect_equal(warp_distance(y, "millisecond"), 0)

  x <- structure(-.001002, tzone = "UTC", class = c("POSIXct", "POSIXt"))
  y <- structure(-.0010002, tzone = "UTC", class = c("POSIXct", "POSIXt"))

  expect_equal(warp_distance(x, "millisecond"), -2)
  expect_equal(warp_distance(y, "millisecond"), -1)
})

test_that("proof that the +1e-7 guard is necessary", {
  # Found this through trial and error
  # I was looking for a place where the scaling up then down by 1e6
  # produces a value that is represented as being `< x`
  # Here we get:

  # 1.000000001327000021935e+09 (start)
  # *1e6
  # 1.000000001327000000000e+15
  # trunc
  # 1.000000001327000000000e+15
  # *1e-6
  # 1.000000001326999902725e+09 (here is the problem! guard required!)
  # +1e-7
  # 1.000000001327000021935e+09 (no guard: 1.000000001326999902725e+09)
  # *1e3
  # 1.000000001327000000000e+12 (no guard: 1.000000001326999877930e+12)
  # floor
  # 1.000000001327000000000e+12 (no guard: 1.000000001326000000000e+12)

  x <- structure(1000000001.327, tzone = "UTC", class = c("POSIXct", "POSIXt"))

  expect_identical(warp_distance(x, "millisecond"), 1000000001327)
})

test_that("default `origin` results in epoch in the time zone of `x`", {
  x <- as.POSIXct("1969-12-31 23:00:00", tz = "America/New_York")
  y <- as.POSIXct("1969-12-31 23:00:00", tz = "UTC")

  expect_equal(
    warp_distance(x, period = "millisecond"),
    warp_distance(y, period = "millisecond")
  )
})

# ------------------------------------------------------------------------------
# warp_distance(<POSIXlt>, period = "millisecond")

test_that("can warp_distance() by millisecond with POSIXlt", {
  x <- as.POSIXct("1970-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "millisecond"), 0)

  x <- as.POSIXct("1971-01-01", tz = "UTC")
  x <- as.POSIXlt(x)
  expect_identical(warp_distance(x, "millisecond"), 31536000 * 1000)
})

# ------------------------------------------------------------------------------
# warp_distance() misc

test_that("`x` is validated", {
  expect_error(warp_distance(1, period = "year"), "must inherit from")
})

test_that("`origin` is validated", {
  expect_error(
    warp_distance(new_date(0), period = "year", origin = 1),
    "must inherit from"
  )
  expect_error(
    warp_distance(new_date(0), period = "year", origin = new_date(c(0, 1))),
    "size 1, not 2"
  )

  expect_error(
    warp_distance(new_date(0), period = "year", origin = new_date(NA_real_)),
    "cannot be `NA`"
  )
  expect_error(
    warp_distance(new_date(0), period = "month", origin = new_date(NA_real_)),
    "cannot be `NA`"
  )
})

test_that("`every` is validated", {
  expect_error(
    warp_distance(new_date(0), period = "year", every = 0),
    "greater than 0, not 0"
  )
  expect_error(
    warp_distance(new_date(0), period = "year", every = -1),
    "greater than 0, not -1"
  )
  expect_error(
    warp_distance(
      new_date(0),
      period = "year",
      every = structure(1, class = "foobar")
    ),
    "bare integer-ish"
  )
  expect_error(
    warp_distance(new_date(0), period = "year", every = "x"),
    "integer-ish, not character"
  )
  expect_error(
    warp_distance(new_date(0), period = "year", every = c(1, 1)),
    "size 1, not 2"
  )
  expect_error(
    warp_distance(new_date(0), period = "year", every = integer()),
    "size 1, not 0"
  )
  expect_error(
    warp_distance(new_date(0), period = "year", every = NA_integer_),
    "`every` must not be `NA`"
  )
})

test_that("`period` is validated", {
  expect_error(warp_distance(new_date(0), period = 1), "single string")
  expect_error(
    warp_distance(new_date(0), period = c("x", "y")),
    "single string"
  )
  expect_error(
    warp_distance(new_date(0), period = "yr"),
    "Unknown `period` value 'yr'"
  )
})

test_that("optional arguments must be specified by name", {
  expect_error(
    warp_distance(new_date(0), "year", 1),
    "`...` is not empty in `warp_distance[(][)]`."
  )
})

dots_n <- function(...) {
  nargs()
}

# Like `ellipsis::check_dots_empty()` but without the import
check_dots_empty <- function(fn, ...) {
  n <- dots_n(...)

  if (n == 0L) {
    return(invisible())
  }

  msg <- paste0(
    "`...` is not empty in `",
    fn,
    "()`.\n",
    "These dots only exist to allow for future extensions and should be empty.\n",
    "Did you misspecify an argument?"
  )

  stop(msg, call. = FALSE)
}

time_class_type <- function(x) {
  .Call(warp_class_type, x)
}

# Callable from C
as_posixct_from_posixlt <- function(x) {
  as.POSIXct.POSIXlt(x)
}

# Callable from C
as_posixlt_from_posixct <- function(x) {
  as.POSIXlt.POSIXct(x)
}

# Callable from C, ensures that the resulting Date
# is a double and has no fractional parts
as_date <- function(x) {
  type <- time_class_type(x)

  if (type == "date") {
    if (typeof(x) == "integer") {
      return(structure(as.double(x), class = "Date"))
    } else {
      # Always truncate towards 0 to get rid of fractional date components
      return(structure(trunc(unclass(x)), class = "Date"))
    }
  }

  if (type == "posixct") {
    return(as.Date.POSIXct(x, tz = tz(x)))
  }

  if (type == "posixlt") {
    return(as.Date.POSIXlt(x))
  }

  stop("Internal error: Unknown date time class", call. = FALSE)
}

# Used in `as_date()`, main thing to ensure of is that
# `as_date()` on a POSIXct retains the year/month/day of that time zone
tz <- function(x) {
  tzone <- attr(x, "tzone")[[1]]

  if (is.null(tzone) && !is_POSIXt(x)) {
    return("UTC")
  }

  if (is.character(tzone) && nzchar(tzone)) {
    return(tzone)
  }

  tzone <- attr(as.POSIXlt(x[0]), "tzone")[[1]]

  if (is.null(tzone)) {
    return("UTC")
  }

  tzone
}

is_POSIXt <- function(x) {
  inherits(x, "POSIXt")
}

#' Detect changes in a date time vector
#'
#' @description
#' `warp_change()` detects changes at the `period` level.
#'
#' If `last = TRUE`, it returns locations of the last value before a change,
#' and the last location in `x` is always included. Additionally, if
#' `endpoint = TRUE`, the first location in `x` will be included.
#'
#' If `last = FALSE`, it returns locations of the first value after a change,
#' and the first location in `x` is always included. Additionally, if
#' `endpoint = TRUE`, the last location in `x` will be included.
#'
#' @inheritParams warp_distance
#'
#' @param last `[logical(1)]`
#'
#'   If `TRUE`, the _last_ location _before_ a change is returned.
#'   The last location of the input is always returned.
#'
#'   If `FALSE`, the _first_ location _after_ a change is returned.
#'   The first location of the input is always returned.
#'
#' @param endpoint `[logical(1)]`
#'
#'   If `TRUE` and `last = TRUE`, will additionally return the first location
#'   of the input.
#'
#'   If `TRUE` and `last = FALSE`, will additionally return the last location
#'   of the input.
#'
#'   If `FALSE`, does nothing.
#'
#' @return
#' A double vector of locations.
#'
#' @export
#' @examples
#' x <- as.Date("2019-01-01") + 0:5
#' x
#'
#' # Last location before a change, last location of `x` is always included
#' warp_change(x, period = "yday", every = 2, last = TRUE)
#'
#' # Also include first location
#' warp_change(x, period = "yday", every = 2, last = TRUE, endpoint = TRUE)
#'
#' # First location after a change, first location of `x` is always included
#' warp_change(x, period = "yday", every = 2, last = FALSE)
#'
#' # Also include last location
#' warp_change(x, period = "yday", every = 2, last = FALSE, endpoint = TRUE)
warp_change <- function(
  x,
  period,
  ...,
  every = 1L,
  origin = NULL,
  last = TRUE,
  endpoint = FALSE
) {
  check_dots_empty("warp_change", ...)
  .Call(warp_warp_change, x, period, every, origin, last, endpoint)
}

#' Compute distances from a date time origin
#'
#' @description
#' `warp_distance()` is a low level engine for computing date time distances.
#'
#' It returns the distance from `x` to the `origin` in units
#' defined by the `period`.
#'
#' For example, `period = "year"` would return the number of years from
#' the `origin`. Setting `every = 2` would return the number of 2 year groups
#' from the `origin`.
#'
#' @details
#' The return value of `warp_distance()` has a variety of uses. It can be used
#' for:
#'
#' - A grouping column in a `dplyr::group_by()`. This is especially useful for
#'   grouping by a multitude of a particular period, such as "every 5 months".
#'
#' - Computing distances between values in `x`, in units of the `period`.
#'   By returning the distances from the `origin`, `warp_distance()` has also
#'   implicitly computed the distances between values of `x`. This is used
#'   by `slide::block()` to break the input into time blocks.
#'
#' When the time zone of `x` differs from the time zone of `origin`, a warning
#' is issued, and `x` is coerced to the time zone of `origin` without changing
#' the number of seconds of `x` from the epoch. In other words, the time zone
#' of `x` is directly changed to the time zone of `origin` without changing the
#' underlying numeric representation. __It is highly advised to specify an
#' `origin` value with the same time zone as `x`.__ If a `Date` is used for
#' `x`, its time zone is assumed to be `"UTC"`.
#'
#' @section Period:
#'
#' For `period` values of `"year"`, `"month"`, and `"day"`, the information
#' provided in `origin` is truncated. Practically this means that if you
#' specify:
#'
#' ```
#' warp_distance(period = "month", origin = as.Date("1970-01-15"))
#' ```
#'
#' then only `1970-01` will be used, and not the fact that the origin starts
#' on the 15th of the month.
#'
#' The `period` value of `"quarter"` is internally
#' `period = "month", every = every * 3`. This means that for `"quarter"`
#' the month specified for the `origin` will be used as the month to start
#' counting from to generate the 3 month quarter.
#'
#' To mimic the behavior of `lubridate::floor_date()`, use `period = "week"`.
#' Internally this is just `period = "day", every = every * 7`. To mimic the
#' `week_start` argument of `floor_date()`, set `origin` to a date
#' with a week day identical to the one you want the week to start from. For
#' example, the default origin of `1970-01-01` is a Thursday, so this would be
#' generate groups identical to `floor_date(week_start = 4)`.
#'
#' The `period` value of `"yday"` is computed as complete `every`-day periods
#' from the `origin`, with a forced reset of the `every`-day counter every
#' time you hit the month-day value of the `origin`. `"yweek"` is built on top
#' of this internally as `period = "yday", every = every * 7`. This ends up
#' using an algorithm very similar to `lubridate::week()`, with the added
#' benefit of being able to control the `origin` date.
#'
#' The `period` value of `"mday"` is computed as `every`-day periods within
#' each month, with a forced reset of the `every`-day counter
#' on the first day of each month. The most useful application of this is
#' `"mweek"`, which is implemented as `period = "mday", every = every * 7`. This
#' allows you to group by the "week of the month". For `"mday"` and `"mweek"`,
#' only the year and month parts of the `origin` value are used. Because of
#' this, the `origin` argument is not that interesting for these periods.
#'
#' The `"hour"` period (and more granular frequencies) can produce results
#' that might be surprising, even if they are technically correct. See the
#' vignette at `vignette("hour", package = "warp")` for more information.
#'
#' @section Precision:
#'
#' With `POSIXct`, the limit of precision is approximately the microsecond
#' level. Only dates that are very close to the unix origin of 1970-01-01 can
#' possibly represent microsecond resolution correctly (close being within
#' about 40 years on either side). Otherwise, the values past the microsecond
#' resolution are essentially random, and can cause problems for the distance
#' calculations. Because of this, decimal digits past the microsecond range are
#' zeroed out, so please do not attempt to rely on them. It should still be safe
#' to work with microseconds, by, say, bucketing them by millisecond distances.
#'
#' @param x `[Date / POSIXct / POSIXlt]`
#'
#'   A date time vector.
#'
#' @param period `[character(1)]`
#'
#'   A string defining the period to group by. Valid inputs can be roughly
#'   broken into:
#'
#'   - `"year"`, `"quarter"`, `"month"`, `"week"`, `"day"`
#'   - `"hour"`, `"minute"`, `"second"`, `"millisecond"`
#'   - `"yweek"`, `"mweek"`
#'   - `"yday"`, `"mday"`
#'
#' @param every `[positive integer(1)]`
#'
#'   The number of periods to group together.
#'
#'   For example, if the period was set to `"year"` with an every value of `2`,
#'   then the years 1970 and 1971 would be placed in the same group.
#'
#' @param origin `[Date(1) / POSIXct(1) / POSIXlt(1) / NULL]`
#'
#'   The reference date time value. The default when left as `NULL` is the
#'   epoch time of `1970-01-01 00:00:00`, _in the time zone of the index_.
#'
#'   This is generally used to define the anchor time to count from, which is
#'   relevant when the every value is `> 1`.
#'
#' @param ... `[dots]`
#'
#'   These dots are for future extensions and must be empty.
#'
#' @return
#' A double vector containing the distances.
#'
#' @export
#' @examples
#' x <- as.Date("1970-01-01") + -4:4
#' x
#'
#' # Compute monthly distances (really, year + month)
#' warp_distance(x, "month")
#'
#' # Compute distances every 2 days, relative to "1970-01-01"
#' warp_distance(x, "day", every = 2)
#'
#' # Compute distances every 2 days, this time relative to "1970-01-02"
#' warp_distance(x, "day", every = 2, origin = as.Date("1970-01-02"))
#'
#' y <- as.POSIXct("1970-01-01 00:00:01", "UTC") + c(0, 2, 3, 4, 5, 6, 10)
#'
#' # Compute distances every 5 seconds, starting from the unix epoch of
#' # 1970-01-01 00:00:00
#' # So this buckets:
#' # [1970-01-01 00:00:00, 1970-01-01 00:00:05) = 0
#' # [1970-01-01 00:00:05, 1970-01-01 00:00:10) = 1
#' # [1970-01-01 00:00:10, 1970-01-01 00:00:15) = 2
#' warp_distance(y, "second", every = 5)
#'
#' # Compute distances every 5 seconds, starting from the minimum of `x`
#' # 1970-01-01 00:00:01
#' # So this buckets:
#' # [1970-01-01 00:00:01, 1970-01-01 00:00:06) = 0
#' # [1970-01-01 00:00:06, 1970-01-01 00:00:11) = 1
#' # [1970-01-01 00:00:11, 1970-01-01 00:00:16) = 2
#' origin <- as.POSIXct("1970-01-01 00:00:01", "UTC")
#' warp_distance(y, "second", every = 5, origin = origin)
#'
#' # ---------------------------------------------------------------------------
#' # Time zones
#'
#' # When `x` is not UTC and `origin` is left as `NULL`, the origin is set as
#' # 1970-01-01 00:00:00 in the time zone of `x`. This seems to be the most
#' # practically useful default.
#' z <- as.POSIXct("1969-12-31 23:00:00", "UTC")
#' z_in_nyc <- as.POSIXct("1969-12-31 23:00:00", "America/New_York")
#'
#' # Practically this means that these give the same result, because their
#' # `origin` values are defined in their respective time zones.
#' warp_distance(z, "year")
#' warp_distance(z_in_nyc, "year")
#'
#' # Compare that to what would happen if we used a static `origin` of
#' # 1970-01-01 00:00:00 UTC.
#' # America/New_York is 5 hours behind UTC, so when `z_in_nyc` is converted to
#' # UTC the value becomes `1970-01-01 04:00:00 UTC`, a different year. Because
#' # this is generally surprising, a warning is thrown.
#' origin <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
#' warp_distance(z, "year", origin = origin)
#' warp_distance(z_in_nyc, "year", origin = origin)
#'
#' # ---------------------------------------------------------------------------
#' # `period = "yweek"`
#'
#' x <- as.Date("2019-12-23") + 0:16
#' origin <- as.Date("1970-01-01")
#'
#' # `"week"` counts the number of 7 day periods from the `origin`
#' # `"yweek"` restarts the 7 day counter every time you hit the month-day
#' # value of the `origin`. Notice how, for the `yweek` column, only 1 day was
#' # in the week starting with `2019-12-31`. This is because the next day is
#' # `2020-01-01`, which aligns with the month-day value of the `origin`.
#' data.frame(
#'   x = x,
#'   week = warp_distance(x, "week", origin = origin),
#'   yweek = warp_distance(x, "yweek", origin = origin)
#' )
#'
#' # ---------------------------------------------------------------------------
#' # `period = "mweek"`
#'
#' x <- as.Date("2019-12-23") + 0:16
#'
#' # `"mweek"` breaks `x` up into weeks of the month. Notice how days 1-7
#' # of 2020-01 all have the same distance value. A forced reset of the 7 day
#' # counter is done at the 1st of every month. This results in the 3 day
#' # week of the month at the end of 2019-12, from 29-31.
#' data.frame(
#'   x = x,
#'   mweek = warp_distance(x, "mweek")
#' )
#'
warp_distance <- function(x, period, ..., every = 1L, origin = NULL) {
  check_dots_empty("warp_distance", ...)
  .Call(warp_warp_distance, x, period, every, origin)
}

# as.POSIXlt.Date() is unbearably slow, this is much faster
as_posixlt_from_date <- function(x) {
  origin <- structure(0, class = "Date")
  x <- unclass(x)

  # Ignore fractional Date pieces by truncating towards 0
  if (typeof(x) == "double") {
    x <- trunc(x)
  }

  out <- as.POSIXlt(x * 86400, tz = "UTC", origin = origin)

  out
}

test_that("getting the year is identical to as.POSIXlt - integer Date", {
  x <- structure(-1e7:1e7, class = "Date")

  expect <- unclass(as_posixlt_from_date(x))
  expect <- expect$year - 70L

  expect_identical(date_get_year_offset(x), expect)
})

test_that("getting the year is identical to as.POSIXlt - double Date", {
  x <- structure(-1e7:1e7 + 0, class = "Date")

  expect <- unclass(as_posixlt_from_date(x))
  expect <- expect$year - 70L

  expect_identical(date_get_year_offset(x), expect)
})

test_that("getting the year month is identical to as.POSIXlt - integer Date", {
  x <- structure(-1e7:1e7, class = "Date")

  expect <- unclass(as_posixlt_from_date(x))
  expect <- (expect$year - 70L) * 12L + expect$mon

  expect_identical(date_get_month_offset(x), expect)
})

test_that("getting the year month is identical to as.POSIXlt - double Date", {
  x <- structure(-1e7:1e7 + 0, class = "Date")

  expect <- unclass(as_posixlt_from_date(x))
  expect <- (expect$year - 70L) * 12L + expect$mon

  expect_identical(date_get_month_offset(x), expect)
})

test_that("can get the year offset of the maximum integer value", {
  x <- structure(.Machine$integer.max, class = "Date")

  expect <- unclass(as_posixlt_from_date(x))
  expect <- expect$year - 70L

  expect_identical(date_get_year_offset(x), expect)
})

test_that("can get the year offset of a value close to the minimum integer value", {
  minimum_allowed_date <- -.Machine$integer.max + unclass(as.Date("2001-01-01"))

  x <- structure(minimum_allowed_date, class = "Date")

  expect <- unclass(as_posixlt_from_date(x))
  expect <- expect$year - 70L

  expect_identical(date_get_year_offset(x), expect)
})

test_that("going below the minimum allowed date is an error", {
  minimum_allowed_date_minus_one <- -.Machine$integer.max +
    unclass(as.Date("2001-01-01")) -
    1L

  x <- structure(minimum_allowed_date_minus_one, class = "Date")

  expect_error(date_get_year_offset(x), "Integer overflow")
})

#!/usr/bin/env bash
set -e

./build-aux/flatpak-cargo-generator.py -o build-aux/cargo-sources.json Cargo.lock || (echo "error generating cargo sources"; exit 0)

builtin type -P yq &> /dev/null || (echo "yq not found, skipping manifest generation"; exit 0)

yq -o json '
.["id"] += ".Devel" |
.["finish-args"] += ["--env=RUST_LOG=warp=debug", "--env=G_MESSAGES_DEBUG=none", "--env=RUST_BACKTRACE=1"] |
.["runtime-version"] = "master" |
.modules[] |= (
    with(select(.name == "warp");
        .["sources"][0] = {
            "type": "dir",
            "path": "../",
            "skip": [
                "target",
                "build",
                "_build",
                "builddir",
                "build-aux/app",
                ".flatpak",
                ".flatpak-builder",
                "build-aux/.flatpak",
                "build-aux/.flatpak-builder",
                "flatpak_out",
                "flatpak_repo",
                ".fenv"
            ]
        } |
        .["config-opts"] += ["-Dprofile=development"] |
        .["config-opts"] -= ["-Dprofile=default"] |
        .["run-tests"] = true
    )
)' \
build-aux/app.drey.Warp.yaml > build-aux/app.drey.Warp.Devel.json.new

set +e

cmp build-aux/app.drey.Warp.Devel.json build-aux/app.drey.Warp.Devel.json.new > /dev/null

if [[ $? -eq 0 ]]; then
  rm build-aux/app.drey.Warp.Devel.json.new
else
  mv build-aux/app.drey.Warp.Devel.json.new build-aux/app.drey.Warp.Devel.json

  # If the manifest has changed, cargp-about output has probably changed as well
  build-aux/generate-licenses.bash
fi

#!/usr/bin/env bash

ninja $(ninja -t targets rule CUSTOM_COMMAND | grep -E "^help.*\.page\$")

while read lang; do
    mkdir -p help-out/$lang
    yelp-build html help/$lang -o help-out/$lang
done < ../help/LINGUAS

mkdir help-out/C
yelp-build html ../help/C -o help-out/C

#!/bin/bash

src="$(find src/ -path '*.rs')"
ui="$(find src/ -path '*.ui')"
git ls-files \
	$src $ui "data/resources/*.ui" "data/*.desktop.in.in" "data/*.xml.in.in" \
	> po/POTFILES.in

cd po || exit 1
intltool-update --maintain 2> /dev/null
cat missing | grep '^\(src\|data\)/'
code=$?
rm missing

if [ $code -eq 0 ]
then
	exit 1
fi

cd ..
xgettext --add-comments --keyword=pgettextf:1c,2 --keyword=npgettextf:1c,2,3 --keyword=gettextf --keyword=ngettextf:1,2 --keyword=ngettextf_:1,2 --from-code=utf-8 --files-from=po/POTFILES.in -o po/warp.pot 2>/dev/null || (echo "Error running xgettext"; exit 1)

#!/bin/bash

APP_ID=app.drey.Warp
REPO_DIR=flatpak_repo

if [[ $1 == "dev" ]]; then
  echo "Using devel manifest"
  APP_ID="$APP_ID.Devel"
  MANIFEST="$APP_ID.json"
  RUNTIME_VERSION="master"
elif [[ $1 == "release" ]]; then
  echo "Using release manifest"
  MANIFEST="$APP_ID.yaml"
  RUNTIME_VERSION="$(yq -r '.["runtime-version"]' build-aux/app.drey.Warp.yaml)"
else
  echo "Run either with dev or release as first argument to select the manifest file"
  exit 1
fi

set -xe

build-aux/generate-manifest.bash || echo "Warning: Problem regenerating devel manifest, using existing manifest"

flatpak remote-add --user --if-not-exists flathub https://flathub.org/repo/flathub.flatpakrepo
flatpak remote-add --user --if-not-exists flathub-beta https://flathub.org/beta-repo/flathub-beta.flatpakrepo
flatpak remote-add --user --if-not-exists gnome-nightly https://nightly.gnome.org/gnome-nightly.flatpakrepo

flatpak install --user --noninteractive org.gnome.Sdk//${RUNTIME_VERSION}
flatpak install --user --noninteractive org.gnome.Platform//${RUNTIME_VERSION}

flatpak install --user --noninteractive org.freedesktop.Sdk.Extension.rust-stable//22.08

flatpak-builder \
  --user --verbose --force-clean --install -y --repo=$REPO_DIR flatpak_out build-aux/$MANIFEST
flatpak build-bundle $REPO_DIR $APP_ID.flatpak $APP_ID

flatpak run $APP_ID//master

#!/usr/bin/env bash
set -e

cargo about -L error generate --all-features --fail --format json |\
    jq 'pick(
        .licenses[].name,
        .licenses[].id,
        .licenses[].text,
        .licenses[].used_by[].crate.name,
        .licenses[].used_by[].crate.authors,
        .licenses[].used_by[].crate.version,
        .licenses[].used_by[].crate.license
    )' > data/licenses.json

---
title: "Hour Distances and Daylight Savings"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Hour Distances and Daylight Savings}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(warp)
```

If using `period = "hour"`, it should work as expected at all times when using a time zone that doesn't have daylight savings, like UTC or EST. If using a time zone with DST, like America/New_York, some additional explanation is required, especially when `every > 1`.

## Spring Forward Gap

In America/New_York's time zone, as time was about to reach `1970-04-26 02:00:00`, daylight savings kicked in and time shifts forward 1 hour so that the next time is actually `1970-04-26 03:00:00`.

```{r}
before_dst <- as.POSIXct("1970-04-26 01:59:59", tz = "America/New_York")
before_dst

before_dst + 1
```

`warp_distance()` treats hours 1 and 3 as being side by side, since no hour 2 ever existed. This means that hours (0, 1) and (3, 4) get grouped together in the below example.

```{r}
x <- as.POSIXct("1970-04-26 00:00:00", tz = "America/New_York") + 3600 * 0:7

data.frame(
  x = x,
  hour = warp_distance(x, "hour", every = 2)
)
```

Because `period = "hour"` just computes the running number of 2 hour periods from the `origin`, this pattern carries forward into the next day to have a contiguous stream of values. This can be somewhat confusing, since hours 0 and 1 don't get grouped together on the 27th.

```{r}
y <- as.POSIXct("1970-04-26 22:00:00", tz = "America/New_York") + 3600 * 0:5

data.frame(
  y = y,
  hour = warp_distance(y, "hour", every = 2)
)
```

One way that you can sort of get around this is by using lubridate's `force_tz()` function to force a UTC time zone with the same clock time as your original date. I've mocked up a poor man's version of that function below.

```{r}
# Or call `lubridate::force_tz(x, "UTC")`
force_utc <- function(x) {
  x_lt <- as.POSIXlt(x)
  x_lt <- unclass(x_lt)
  
  attributes(x) <- NULL
  
  out <- x + x_lt$gmtoff
  
  as.POSIXct(out, tz = "UTC", origin = "1970-01-01")
}

x_utc <- force_utc(x)
y_utc <- force_utc(y)

x_utc
```

In UTC, hour 2 exists so groups are created as (0, 1), (2, 3), and so on, even though hour 2 doesn't actually exist in America/New_York because of the DST gap. This has the affect of limiting the (2, 3) group to a maximum size of 1, since only hour 3 is possible in the data.

```{r}
data.frame(
  x_utc = x_utc,
  hour = warp_distance(x_utc, "hour", every = 2)
)

data.frame(
  y_utc = y_utc,
  hour = warp_distance(y_utc, "hour", every = 2)
)
```

## Fall Backwards Overlap

In America/New_York's time zone, as time was about to reach `1970-10-25 02:00:00`, daylight savings kicked in and time shifts backwards 1 hour so that the next time is actually `1970-10-25 01:00:00`. This means there are 2 full hours with an hour value of 1 in that day.

```{r}
before_fallback <- as.POSIXct("1970-10-25 01:00:00", tz = "America/New_York")
before_fallback

# add 1 hour of seconds
before_fallback + 3600
```

Because these are two distinct hours, `warp_distance()` treats them as such, so in the example below a group of (1 EDT, 1 EST) gets created. Since daylight savings is currently active, we also have the situation described above where hour 0 and hour 1 are not grouped together.

```{r}
x <- as.POSIXct("1970-10-25 00:00:00", tz = "America/New_York") + 3600 * 0:7
x

data.frame(
  x = x,
  hour = warp_distance(x, "hour", every = 2)
)
```

This fallback adjustment actually realigns hours 0 and 1 in the next day, since the 25th has 25 hours.

```{r}
y <- as.POSIXct("1970-10-25 22:00:00", tz = "America/New_York") + 3600 * 0:5
y

data.frame(
  y = y,
  hour = warp_distance(y, "hour", every = 2)
)
```

As before, one way to sort of avoid this is to force a UTC time zone.

```{r}
x_utc <- force_utc(x)
x_utc
```

The consequences of this are that you have two dates with an hour value of 1. When forced to UTC, these look identical. The groups are as you probably expect with buckets of hours (0, 1), (2, 3), and so on, but now the two dates with hour values of 1 are identical so they fall in the same hour group.

```{r}
data.frame(
  x_utc = x_utc,
  hour = warp_distance(x_utc, "hour", every = 2)
)
```

## Conclusion

While the implementation of `period = "hour"` is _technically_ correct, I recognize that it isn't the most intuitive operation. More intuitive would be a period value of `"dhour"`, which would correspond to the "hour of the day". This would count the number of hour groups from the origin, like `"hour"` does, but it would reset the `every`-hour counter every time you enter a new day. However, this has proved to be challenging to code up, but I hope to incorporate this eventually.

# Contributing
Contributions of all kind and with all levels of experience are very welcome. 

## Code of Conduct

When interacting with the project, the [GNOME Code Of Conduct](https://conduct.gnome.org/) applies.

## Use of Generative AI

This project does not allow contributions generated by large languages models (LLMs) and chatbots. This ban includes tools like ChatGPT, Claude, Copilot, DeepSeek, and Devin AI. We are taking these steps as precaution due to the potential negative influence of AI generated content on quality, as well as likely copyright violations.

This ban of AI generated content applies to all parts of the projects, including, but not limited to, code, documentation, issues, and artworks. An exception applies for purely translating texts for issues and comments to English.

AI tools can be used to answer questions and find information. However, we encourage contributors to avoid them in favor of using [existing documentation](https://developer.gnome.org) and our [chats and forums](https://welcome.gnome.org). Since AI generated information is frequently misleading or false, we cannot supply support on anything referencing AI output.

## Translation
The translation of Warp is managed by the GNOME Translation Project and the respective language teams. The translation status is available on the module page.

[Translation status](https://l10n.gnome.org/module/warp/)

## Help format
The help pages are currently written in ducktype. The files are stored in help/C/duck and the corresponding .page-files can be generated via make -C help/C/. Afterwards, you can preview the generated help pages via yelp help/C/index.page. The generated .page-files have to be committed to the repository as well. The ducktype program required for running make is probably packaged in you distro and is also availabe on GitHub.

## Development
### Cargo

Compiling and running the project via cargo is possible. This is mostly helpful when debugging as the round-trip time is
faster. When running via cargo the following features
are not available:

* Help pages
* Translations

It is required to test any big changes with flatpak before contributing any new code.

The manifest and `cargo-sources.json` need to be regenerated by running `build-aux/generate-manifest.bash` after changing dependencies in `Cargo.lock`.

### Debugging

The log level can be adjusted by setting the `RUST_LOG` variable:

```shell
RUST_LOG=debug cargo run
```

### Release

Creating a release:

- Update version in `Cargo.toml`
- Run `cargo` to update `Cargo.lock`
- Run `build-aux/generate-manifest.bash`
- Update `data/app.drey.Warp.metainfo.xml.in.in`
  - Add/Update release section with current date, version and release notes
  - Update screenshots
- Update flathub repo and create PR
- Test flathub build
- Merge flathub PR
- Tag the release

<!--
Thank you for taking your time to submit an issue.

By submitting an issue you agree to follow the [GNOME Code of Conduct](https://wiki.gnome.org/Foundation/CodeOfConduct).

Before submitting an issue about a network problem, please check your own internet connection first. If the rendezvous server is unreachable, please try again some time later to allow for temporary server outages. It is also be possible that the server is blocked in your country.
-->

## Issue description

## Version information
<!-- eg. Version x.x.x from Flathub -->

# Date + non-UTC origin converts with a warning

    Code
      out <- warp_distance(x, "year", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "month", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "yweek", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "mday", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "day", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "hour", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "minute", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "second", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "millisecond", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

# UTC POSIXct + non-UTC origin converts with a warning

    Code
      out <- warp_distance(x, "year", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "month", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "yweek", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "mday", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "day", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "hour", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "minute", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "second", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "millisecond", origin = origin)
    Condition
      Warning:
      `x` (UTC) and `origin` (America/New_York) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

# local time POSIXct + UTC origin converts with a warning

    Code
      out <- warp_distance(x, "year", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "month", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "yweek", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "mday", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "day", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "hour", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "minute", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "second", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

---

    Code
      out <- warp_distance(x, "millisecond", origin = origin)
    Condition
      Warning:
      `x` (local) and `origin` (UTC) do not have the same time zone. Converting `x` to the time zone of `origin`. It is highly advised to provide `x` and `origin` with the same time zone.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/boundary.R
\name{warp_boundary}
\alias{warp_boundary}
\title{Locate period boundaries for a date vector}
\usage{
warp_boundary(x, period, ..., every = 1L, origin = NULL)
}
\arguments{
\item{x}{\verb{[Date / POSIXct / POSIXlt]}

A date time vector.}

\item{period}{\verb{[character(1)]}

A string defining the period to group by. Valid inputs can be roughly
broken into:
\itemize{
\item \code{"year"}, \code{"quarter"}, \code{"month"}, \code{"week"}, \code{"day"}
\item \code{"hour"}, \code{"minute"}, \code{"second"}, \code{"millisecond"}
\item \code{"yweek"}, \code{"mweek"}
\item \code{"yday"}, \code{"mday"}
}}

\item{...}{\verb{[dots]}

These dots are for future extensions and must be empty.}

\item{every}{\verb{[positive integer(1)]}

The number of periods to group together.

For example, if the period was set to \code{"year"} with an every value of \code{2},
then the years 1970 and 1971 would be placed in the same group.}

\item{origin}{\verb{[Date(1) / POSIXct(1) / POSIXlt(1) / NULL]}

The reference date time value. The default when left as \code{NULL} is the
epoch time of \verb{1970-01-01 00:00:00}, \emph{in the time zone of the index}.

This is generally used to define the anchor time to count from, which is
relevant when the every value is \verb{> 1}.}
}
\value{
A two column data frame with the columns \code{start} and \code{stop}. Both are
double vectors representing boundaries of the date time groups.
}
\description{
\code{warp_boundary()} detects a change in time period along \code{x}, for example,
rolling from one month to the next. It returns the start and stop positions
for each contiguous period chunk in \code{x}.
}
\details{
The stop positions are just the \code{\link[=warp_change]{warp_change()}} values, and the start
positions are computed from these.
}
\examples{
x <- as.Date("1970-01-01") + -4:5
x

# Boundaries by month
warp_boundary(x, "month")

# Bound by every 5 days, relative to "1970-01-01"
# Creates boundaries of:
# [1969-12-27, 1970-01-01)
# [1970-01-01, 1970-01-06)
# [1970-01-06, 1970-01-11)
warp_boundary(x, "day", every = 5)

# Bound by every 5 days, relative to the smallest value in our vector
origin <- min(x)
origin

# Creates boundaries of:
# [1969-12-28, 1970-01-02)
# [1970-01-02, 1970-01-07)
warp_boundary(x, "day", every = 5, origin = origin)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distance.R
\name{warp_distance}
\alias{warp_distance}
\title{Compute distances from a date time origin}
\usage{
warp_distance(x, period, ..., every = 1L, origin = NULL)
}
\arguments{
\item{x}{\verb{[Date / POSIXct / POSIXlt]}

A date time vector.}

\item{period}{\verb{[character(1)]}

A string defining the period to group by. Valid inputs can be roughly
broken into:
\itemize{
\item \code{"year"}, \code{"quarter"}, \code{"month"}, \code{"week"}, \code{"day"}
\item \code{"hour"}, \code{"minute"}, \code{"second"}, \code{"millisecond"}
\item \code{"yweek"}, \code{"mweek"}
\item \code{"yday"}, \code{"mday"}
}}

\item{...}{\verb{[dots]}

These dots are for future extensions and must be empty.}

\item{every}{\verb{[positive integer(1)]}

The number of periods to group together.

For example, if the period was set to \code{"year"} with an every value of \code{2},
then the years 1970 and 1971 would be placed in the same group.}

\item{origin}{\verb{[Date(1) / POSIXct(1) / POSIXlt(1) / NULL]}

The reference date time value. The default when left as \code{NULL} is the
epoch time of \verb{1970-01-01 00:00:00}, \emph{in the time zone of the index}.

This is generally used to define the anchor time to count from, which is
relevant when the every value is \verb{> 1}.}
}
\value{
A double vector containing the distances.
}
\description{
\code{warp_distance()} is a low level engine for computing date time distances.

It returns the distance from \code{x} to the \code{origin} in units
defined by the \code{period}.

For example, \code{period = "year"} would return the number of years from
the \code{origin}. Setting \code{every = 2} would return the number of 2 year groups
from the \code{origin}.
}
\details{
The return value of \code{warp_distance()} has a variety of uses. It can be used
for:
\itemize{
\item A grouping column in a \code{dplyr::group_by()}. This is especially useful for
grouping by a multitude of a particular period, such as "every 5 months".
\item Computing distances between values in \code{x}, in units of the \code{period}.
By returning the distances from the \code{origin}, \code{warp_distance()} has also
implicitly computed the distances between values of \code{x}. This is used
by \code{slide::block()} to break the input into time blocks.
}

When the time zone of \code{x} differs from the time zone of \code{origin}, a warning
is issued, and \code{x} is coerced to the time zone of \code{origin} without changing
the number of seconds of \code{x} from the epoch. In other words, the time zone
of \code{x} is directly changed to the time zone of \code{origin} without changing the
underlying numeric representation. \strong{It is highly advised to specify an
\code{origin} value with the same time zone as \code{x}.} If a \code{Date} is used for
\code{x}, its time zone is assumed to be \code{"UTC"}.
}
\section{Period}{


For \code{period} values of \code{"year"}, \code{"month"}, and \code{"day"}, the information
provided in \code{origin} is truncated. Practically this means that if you
specify:

\if{html}{\out{<div class="sourceCode">}}\preformatted{warp_distance(period = "month", origin = as.Date("1970-01-15"))
}\if{html}{\out{</div>}}

then only \code{1970-01} will be used, and not the fact that the origin starts
on the 15th of the month.

The \code{period} value of \code{"quarter"} is internally
\verb{period = "month", every = every * 3}. This means that for \code{"quarter"}
the month specified for the \code{origin} will be used as the month to start
counting from to generate the 3 month quarter.

To mimic the behavior of \code{lubridate::floor_date()}, use \code{period = "week"}.
Internally this is just \verb{period = "day", every = every * 7}. To mimic the
\code{week_start} argument of \code{floor_date()}, set \code{origin} to a date
with a week day identical to the one you want the week to start from. For
example, the default origin of \code{1970-01-01} is a Thursday, so this would be
generate groups identical to \code{floor_date(week_start = 4)}.

The \code{period} value of \code{"yday"} is computed as complete \code{every}-day periods
from the \code{origin}, with a forced reset of the \code{every}-day counter every
time you hit the month-day value of the \code{origin}. \code{"yweek"} is built on top
of this internally as \verb{period = "yday", every = every * 7}. This ends up
using an algorithm very similar to \code{lubridate::week()}, with the added
benefit of being able to control the \code{origin} date.

The \code{period} value of \code{"mday"} is computed as \code{every}-day periods within
each month, with a forced reset of the \code{every}-day counter
on the first day of each month. The most useful application of this is
\code{"mweek"}, which is implemented as \verb{period = "mday", every = every * 7}. This
allows you to group by the "week of the month". For \code{"mday"} and \code{"mweek"},
only the year and month parts of the \code{origin} value are used. Because of
this, the \code{origin} argument is not that interesting for these periods.

The \code{"hour"} period (and more granular frequencies) can produce results
that might be surprising, even if they are technically correct. See the
vignette at \code{vignette("hour", package = "warp")} for more information.
}

\section{Precision}{


With \code{POSIXct}, the limit of precision is approximately the microsecond
level. Only dates that are very close to the unix origin of 1970-01-01 can
possibly represent microsecond resolution correctly (close being within
about 40 years on either side). Otherwise, the values past the microsecond
resolution are essentially random, and can cause problems for the distance
calculations. Because of this, decimal digits past the microsecond range are
zeroed out, so please do not attempt to rely on them. It should still be safe
to work with microseconds, by, say, bucketing them by millisecond distances.
}

\examples{
x <- as.Date("1970-01-01") + -4:4
x

# Compute monthly distances (really, year + month)
warp_distance(x, "month")

# Compute distances every 2 days, relative to "1970-01-01"
warp_distance(x, "day", every = 2)

# Compute distances every 2 days, this time relative to "1970-01-02"
warp_distance(x, "day", every = 2, origin = as.Date("1970-01-02"))

y <- as.POSIXct("1970-01-01 00:00:01", "UTC") + c(0, 2, 3, 4, 5, 6, 10)

# Compute distances every 5 seconds, starting from the unix epoch of
# 1970-01-01 00:00:00
# So this buckets:
# [1970-01-01 00:00:00, 1970-01-01 00:00:05) = 0
# [1970-01-01 00:00:05, 1970-01-01 00:00:10) = 1
# [1970-01-01 00:00:10, 1970-01-01 00:00:15) = 2
warp_distance(y, "second", every = 5)

# Compute distances every 5 seconds, starting from the minimum of `x`
# 1970-01-01 00:00:01
# So this buckets:
# [1970-01-01 00:00:01, 1970-01-01 00:00:06) = 0
# [1970-01-01 00:00:06, 1970-01-01 00:00:11) = 1
# [1970-01-01 00:00:11, 1970-01-01 00:00:16) = 2
origin <- as.POSIXct("1970-01-01 00:00:01", "UTC")
warp_distance(y, "second", every = 5, origin = origin)

# ---------------------------------------------------------------------------
# Time zones

# When `x` is not UTC and `origin` is left as `NULL`, the origin is set as
# 1970-01-01 00:00:00 in the time zone of `x`. This seems to be the most
# practically useful default.
z <- as.POSIXct("1969-12-31 23:00:00", "UTC")
z_in_nyc <- as.POSIXct("1969-12-31 23:00:00", "America/New_York")

# Practically this means that these give the same result, because their
# `origin` values are defined in their respective time zones.
warp_distance(z, "year")
warp_distance(z_in_nyc, "year")

# Compare that to what would happen if we used a static `origin` of
# 1970-01-01 00:00:00 UTC.
# America/New_York is 5 hours behind UTC, so when `z_in_nyc` is converted to
# UTC the value becomes `1970-01-01 04:00:00 UTC`, a different year. Because
# this is generally surprising, a warning is thrown.
origin <- as.POSIXct("1970-01-01 00:00:00", tz = "UTC")
warp_distance(z, "year", origin = origin)
warp_distance(z_in_nyc, "year", origin = origin)

# ---------------------------------------------------------------------------
# `period = "yweek"`

x <- as.Date("2019-12-23") + 0:16
origin <- as.Date("1970-01-01")

# `"week"` counts the number of 7 day periods from the `origin`
# `"yweek"` restarts the 7 day counter every time you hit the month-day
# value of the `origin`. Notice how, for the `yweek` column, only 1 day was
# in the week starting with `2019-12-31`. This is because the next day is
# `2020-01-01`, which aligns with the month-day value of the `origin`.
data.frame(
  x = x,
  week = warp_distance(x, "week", origin = origin),
  yweek = warp_distance(x, "yweek", origin = origin)
)

# ---------------------------------------------------------------------------
# `period = "mweek"`

x <- as.Date("2019-12-23") + 0:16

# `"mweek"` breaks `x` up into weeks of the month. Notice how days 1-7
# of 2020-01 all have the same distance value. A forced reset of the 7 day
# counter is done at the 1st of every month. This results in the 3 day
# week of the month at the end of 2019-12, from 29-31.
data.frame(
  x = x,
  mweek = warp_distance(x, "mweek")
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/change.R
\name{warp_change}
\alias{warp_change}
\title{Detect changes in a date time vector}
\usage{
warp_change(
  x,
  period,
  ...,
  every = 1L,
  origin = NULL,
  last = TRUE,
  endpoint = FALSE
)
}
\arguments{
\item{x}{\verb{[Date / POSIXct / POSIXlt]}

A date time vector.}

\item{period}{\verb{[character(1)]}

A string defining the period to group by. Valid inputs can be roughly
broken into:
\itemize{
\item \code{"year"}, \code{"quarter"}, \code{"month"}, \code{"week"}, \code{"day"}
\item \code{"hour"}, \code{"minute"}, \code{"second"}, \code{"millisecond"}
\item \code{"yweek"}, \code{"mweek"}
\item \code{"yday"}, \code{"mday"}
}}

\item{...}{\verb{[dots]}

These dots are for future extensions and must be empty.}

\item{every}{\verb{[positive integer(1)]}

The number of periods to group together.

For example, if the period was set to \code{"year"} with an every value of \code{2},
then the years 1970 and 1971 would be placed in the same group.}

\item{origin}{\verb{[Date(1) / POSIXct(1) / POSIXlt(1) / NULL]}

The reference date time value. The default when left as \code{NULL} is the
epoch time of \verb{1970-01-01 00:00:00}, \emph{in the time zone of the index}.

This is generally used to define the anchor time to count from, which is
relevant when the every value is \verb{> 1}.}

\item{last}{\verb{[logical(1)]}

If \code{TRUE}, the \emph{last} location \emph{before} a change is returned.
The last location of the input is always returned.

If \code{FALSE}, the \emph{first} location \emph{after} a change is returned.
The first location of the input is always returned.}

\item{endpoint}{\verb{[logical(1)]}

If \code{TRUE} and \code{last = TRUE}, will additionally return the first location
of the input.

If \code{TRUE} and \code{last = FALSE}, will additionally return the last location
of the input.

If \code{FALSE}, does nothing.}
}
\value{
A double vector of locations.
}
\description{
\code{warp_change()} detects changes at the \code{period} level.

If \code{last = TRUE}, it returns locations of the last value before a change,
and the last location in \code{x} is always included. Additionally, if
\code{endpoint = TRUE}, the first location in \code{x} will be included.

If \code{last = FALSE}, it returns locations of the first value after a change,
and the first location in \code{x} is always included. Additionally, if
\code{endpoint = TRUE}, the last location in \code{x} will be included.
}
\examples{
x <- as.Date("2019-01-01") + 0:5
x

# Last location before a change, last location of `x` is always included
warp_change(x, period = "yday", every = 2, last = TRUE)

# Also include first location
warp_change(x, period = "yday", every = 2, last = TRUE, endpoint = TRUE)

# First location after a change, first location of `x` is always included
warp_change(x, period = "yday", every = 2, last = FALSE)

# Also include last location
warp_change(x, period = "yday", every = 2, last = FALSE, endpoint = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/warp-package.R
\docType{package}
\name{warp-package}
\alias{warp}
\alias{warp-package}
\title{warp: Group Dates}
\description{
Tooling to group dates by a variety of periods including: yearly, monthly, by second, by week of the month, and more. The groups are defined in such a way that they also represent the distance between dates in terms of the period. This extracts valuable information that can be used in further calculations that rely on a specific temporal spacing between observations.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/DavisVaughan/warp}
  \item \url{https://davisvaughan.github.io/warp/}
  \item Report bugs at \url{https://github.com/DavisVaughan/warp/issues}
}

}
\author{
\strong{Maintainer}: Davis Vaughan \email{davis@posit.co}

Other contributors:
\itemize{
  \item Posit Software, PBC (\href{https://ror.org/03wc8by49}{ROR}) [copyright holder, funder]
}

}
\keyword{internal}
